$BonesModVersion = "1.03";

function makeparticleemitter(%location,%emittertype,%velocity,%duration) {
	%emitterid = new ParticleEmissionDummy() {
		position = %location;
		rotation = "0 0 1 0";
		dataBlock = "defaultEmissionDummy";
		emitter = %emittertype;
		velocity = %velocity;
	};
	MissionCleanup.add(%emitterid);
	if (%duration > 0)
		%emitterid.schedule(%duration, "delete");
	return %emitterid;
}

function isNecroBones (%client) {
  if  ((%client.guid == 20075) || (%client.guid == 296071)) 
	return true;
  else
	return false;
}

function uptime() {
	$uptimeseconds = mFloor(getsimtime()/1000);
	$uptimeminutes = mFloor(getsimtime()/60000);
	$uptimehours   = mFloor(getsimtime()/3600000);
	$uptimeminleftover = $uptimeminutes - ($uptimehours*60);
	if ($uptimeseconds < 60)
		$uptime = $uptimeseconds @ " seconds.";
	else if ($uptimeminutes < 60)
		$uptime = $uptimeminutes @ " minutes.";
	else
		$uptime = $uptimehours @ " hours, " @ $uptimeminleftover @ " minutes. (" @ $uptimeminutes @ " minutes)";
	echo("Uptime: " @ $uptime);
	return $uptime;
}

function makeadminspawnpad() {
   %group = nameToID("MissionGroup/Teams");
   if(%group == -1)
      return;

   // create a team3 if it does not exist
   %teamgrp = nameToID("MissionGroup/Teams/team3");
   if(%teamgrp == -1)
   {
      %teamgrp = new SimGroup("team3");
      %group.add(%teamgrp);
   }

   %beacon = new BeaconObject() {
                  dataBlock = "DeployedBeacon";
                  position = "3000 3000 400";
                  rotation = "1 0 0 0";
                  team = 3;
   };
   %beacon.setBeaconType(friend);
   %beacon.setTarget(3);

   %beacon2 = new BeaconObject() {
                  dataBlock = "DeployedBeacon";
                  position = "0 0 0";
                  rotation = "1 0 0 0";
                  team = 3;
   };
   %beacon2.setBeaconType(friend);
   %beacon2.setTarget(3);


   %misarea = nameToID("MissionGroup/MissionArea");
   if(%misarea != -1)
   {
	if (%misarea.FlightCeiling < 500) {
		%misarea.FlightCeiling = 500;
		echo("Mission Area Flight Ceiling increased to 500.");
	} else
		echo("Mission Area Flight Ceiling already 500 or higher.");
   } else 
	echo("Mission Area not found!");

 %base = new SimGroup(RefereeFloatBase) {
   powerCount = "0";
   providespower = "1";

	new InteriorInstance(adminpad) {
		position = "3000 3000 400";
		rotation = "1 0 0 0";
		scale = "2 2 2";
		interiorFile = "dvpad1.dif";
		showTerrainInside = "0";
			team = "3";
	};
	new FlyingVehicle() {
		position = "2985 3025 410";
		rotation = "0 0 1 180";
		scale = "1 1 1";
		dataBlock = "AdminFlyer";
		lockCount = "0";
		homingCount = "0";
		disableMove = "0";
			selfPower = "1";
			respawn = "1";
			mountable = "1";
			respawnTime = "10000";
			respawn = "1";
			team = "3";
			teamBought = "3";
	};
	new FlyingVehicle() {
		position = "3015 3025 410";
		rotation = "0 0 1 180";
		scale = "1 1 1";
		dataBlock = "ATFlyer";
		lockCount = "0";
		homingCount = "0";
		disableMove = "0";
			selfPower = "1";
			respawn = "1";
			mountable = "1";
			respawnTime = "10000";
			respawn = "1";
			team = "3";
			teamBought = "3";
	};
	new HoverVehicle() {
		position = "2985 2979 412";
		rotation = "0 0 1 180";
		scale = "1 1 1";
		dataBlock = "AdminTankVehicle";
		lockCount = "0";
		homingCount = "0";
		disableMove = "0";
		nextWeaponFire = "2";
			selfPower = "1";
			respawn = "1";
			mountable = "1";
			respawnTime = "10000";
			respawn = "1";
			team = "3";
			teamBought = "3";
	};
	new FlyingVehicle() {
		position = "3015 3002 410";
		rotation = "0 0 1 180";
		scale = "1 1 1";
		dataBlock = "AdminFighterFlyer";
		lockCount = "0";
		homingCount = "0";
		disableMove = "0";
			nextWeaponFire = "2";
			selfPower = "1";
			respawn = "1";
			mountable = "1";
			respawnTime = "10000";
			respawn = "1";
			team = "3";
			teamBought = "3";
	};
	new HoverVehicle() {
		position = "2985 3002 412";
		rotation = "0 0 1 180";
		scale = "1 1 1";
		dataBlock = "AdminTankVehicle";
		lockCount = "0";
		homingCount = "0";
		disableMove = "0";
		nextWeaponFire = "2";
			selfPower = "1";
			respawn = "1";
			mountable = "1";
			respawnTime = "10000";
			respawn = "1";
			team = "3";
			teamBought = "3";
	};
	new FlyingVehicle() {
		position = "3015 2979 410";
		rotation = "0 0 1 180";
		scale = "1 1 1";
		dataBlock = "AdminFighterFlyer";
		lockCount = "0";
		homingCount = "0";
		disableMove = "0";
			nextWeaponFire = "2";
			selfPower = "1";
			respawn = "1";
			mountable = "1";
			respawnTime = "10000";
			respawn = "1";
			team = "3";
			teamBought = "3";
	};
	new Item() {
		position = "3001.5 2961 404.15";
		rotation = "1 0 0 0";
		scale = "1 1 1";
		dataBlock = "RepairPack";
		lockCount = "0";
		homingCount = "0";
		collideable = "0";
		static = "1";
		rotate = "1";
			Target = "-1";
	};
	new Item() {
		position = "2998.5 2961 404.15";
		rotation = "1 0 0 0";
		scale = "1 1 1";
		dataBlock = "RepairPack";
		lockCount = "0";
		homingCount = "0";
		collideable = "0";
		static = "1";
		rotate = "1";
			Target = "-1";
	};
	new Item() {
		position = "3025 2964 404.15";
		rotation = "1 0 0 0";
		scale = "1 1 1";
		dataBlock = "SensorJammerPack";
		lockCount = "0";
		homingCount = "0";
		collideable = "0";
		static = "1";
		rotate = "1";
			Target = "-1";
	};
	new Item() {
		position = "2975 2964 404.15";
		rotation = "1 0 0 0";
		scale = "1 1 1";
		dataBlock = "SensorJammerPack";
		lockCount = "0";
		homingCount = "0";
		collideable = "0";
		static = "1";
		rotate = "1";
		Target = "-1";
	};
	new Item() {
		position = "3015 2964 404.15";
		rotation = "1 0 0 0";
		scale = "1 1 1";
		dataBlock = "CloakingPack";
		lockCount = "0";
		homingCount = "0";
		collideable = "0";
		static = "1";
		rotate = "1";
			Target = "-1";
	};
	new Item() {
		position = "2985 2964 404.15";
		rotation = "1 0 0 0";
		scale = "1 1 1";
		dataBlock = "CamoPack";
		lockCount = "0";
		homingCount = "0";
		collideable = "0";
		static = "1";
		rotate = "1";
		Target = "-1";
	};
	new Item() {
		position = "3020 2964 404.15";
		rotation = "1 0 0 0";
		scale = "1 1 1";
		dataBlock = "SatchelCharge";
		lockCount = "0";
		homingCount = "0";
		collideable = "0";
		static = "1";
		rotate = "1";
			Target = "-1";
	};
	new Item() {
		position = "2980 2964 404.15";
		rotation = "1 0 0 0";
		scale = "1 1 1";
		dataBlock = "TreePack";
		lockCount = "0";
		homingCount = "0";
		collideable = "0";
		static = "1";
		rotate = "1";
		Target = "-1";
	};
	new Item() {
		position = "3000 3075 404";
		rotation = "1 0 0 0";
		scale = "1 1 1";
		dataBlock = "TurretBaseDeployable";
		lockCount = "0";
		homingCount = "0";
		collideable = "0";
		static = "1";
		rotate = "1";
			Target = "-1";
	};
	new Item() {
		position = "3000 3070 404";
		rotation = "1 0 0 0";
		scale = "1 1 1";
		dataBlock = "InventoryDeployable";
		lockCount = "0";
		homingCount = "0";
		collideable = "0";
		static = "1";
		rotate = "1";
			Target = "-1";
	};
	new Item() {
		position = "3005 3070 404";
		rotation = "1 0 0 0";
		scale = "1 1 1";
		dataBlock = "TurretIndoorDeployable";
		lockCount = "0";
		homingCount = "0";
		collideable = "0";
		static = "1";
		rotate = "1";
			Target = "-1";
	};
	new Item() {
		position = "2995 3070 404";
		rotation = "1 0 0 0";
		scale = "1 1 1";
		dataBlock = "TurretIndoorDeployable";
		lockCount = "0";
		homingCount = "0";
		collideable = "0";
		static = "1";
		rotate = "1";
			Target = "-1";
	};
	new Turret() {
		position = "3000 2992 404";
		rotation = "1 0 0 0";
		scale = "1 1 1";
		nameTag = "RefBase";
		dataBlock = "TurretBaseLarge";
		lockCount = "0";
		homingCount = "0";
		initialBarrel = "TorpedoBarrelLarge";
	};
	new Turret() {
		position = "3000 3008 404";
		rotation = "0 0 1 180";
		scale = "1 1 1";
		nameTag = "RefBase";
		dataBlock = "TurretBaseLarge";
		lockCount = "0";
		homingCount = "0";
		initialBarrel = "TorpedoBarrelLarge";
	};
	new Turret() {
		position = "3000 2956 408";
		rotation = "1 0 0 180";
		scale = "1 1 1";
		nameTag = "RefSentry";
		dataBlock = "SentryTurret";
		lockCount = "0";
		homingCount = "0";
		initialBarrel = "SentryTurretBarrel";
	};
	new Turret() {
		position = "3000 3050.2 404";
		rotation = "1 0 0 180";
		scale = "1 1 1";
		nameTag = "RefSentry";
		dataBlock = "SentryTurret";
		lockCount = "0";
		homingCount = "0";
		initialBarrel = "SentryTurretBarrel";
	};
	new StaticShape() {
		position = "2965.8 3000 403.8";
		rotation = "0 0 -1 90";
		scale = "1 1 1";
		nameTag = "RefBase";
		dataBlock = "SensorLargePulse";
		lockCount = "0";
		homingCount = "0";
	};
	new StaticShape() {
		position = "3034.2 3000 403.8";
		rotation = "0 0 1 90";
		scale = "1 1 1";
		nameTag = "RefBase";
		dataBlock = "SensorLargePulse";
		lockCount = "0";
		homingCount = "0";
	};
	new StaticShape() {
		position = "3030 3000 396.2";
		rotation = "0.707388 0.706825 -3.08963e-08 180";
		scale = "1 1 1";
		nameTag = "RefBase";
		dataBlock = "SensorLargePulse";
		lockCount = "0";
		homingCount = "0";
	};
	new StaticShape() {
		position = "2970 3000 396.2";
		rotation = "0.707388 -0.706825 4.36868e-08 180";
		scale = "1 1 1";
		nameTag = "RefBase";
		dataBlock = "SensorLargePulse";
		lockCount = "0";
		homingCount = "0";
	};
	new Turret() {
		position = "3000 3036 396";
		rotation = "0 1 0 180";
		scale = "1 1 1";
		nameTag = "HullBase";
		dataBlock = "TurretBaseLarge";
		lockCount = "0";
		homingCount = "0";
		initialBarrel = "TorpedoBarrelLarge";
			team = "3";
	};
	new Turret() {
		position = "3000 2974 396";
		rotation = "1 0 0 180";
		scale = "1 1 1";
		nameTag = "HullBase";
		dataBlock = "TurretBaseLarge";
		lockCount = "0";
		homingCount = "0";
		initialBarrel = "TorpedoBarrelLarge";
			team = "3";
	};
	new Turret() {
		position = "3000 3093.4 404";
		rotation = "1 0 0 0";
		scale = "1 1 1";
		nameTag = "RefPlatform";
		dataBlock = "TurretBaseLarge";
		lockCount = "0";
		homingCount = "0";
		initialBarrel = "TorpedoBarrelLarge";
			team = "3";
	};
 };
 %teamgrp.add(%base);

 if ($Host::BonesAdminChaos && $currentMissionType $= "CTF") {
	%flag  = new Item() {
		position = "3000 3060 404";
		rotation = "1 0 0 0";
		scale = "1 1 1";
		dataBlock = "Flag";
		lockCount = "0";
		homingCount = "0";
		collideable = "0";
		static = "0";
		rotate = "1";
		team = "3";
		className = "FlagObj";
	};
        %teamgrp.add(%flag);
 }

//   %refspawnplatform = new TSStatic() {
//		position = "0 0 490";
//		rotation = "0 0 1 90";
//		scale = "2 2 2";
//		shapeName = "bmiscf.dts";
//	};
//    %refspawnplatform = new ForceFieldBare() {
//	position = "-3 -3 490";
//	rotation = "0 0 1 0";
//	scale = "6 6 0.2";
//	dataBlock = "defaultForceFieldBare";
//	team = "3";
//	selfpowered = "1";
//	isselfpowered = "1";
//   };
//   MissionCleanup.add(%refspawnplatform);
//   %refspawnplatform.schedule(120000, "delete");

}



datablock AudioProfile(RefTeleportSoundEnter)
{
   filename    = "fx/powered/vehicle_screen_on.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(RefTeleportSoundExit)
{
   filename    = "fx/packs/shield_hit.wav";  
   description = AudioClosest3d;
   preload = true;
};

datablock ParticleData(refteleportparticle)
{
   dragCoefficient      = 1.5;
   gravityCoefficient   = 0.2;

   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;

   lifetimeMS           = 1250;
   lifetimeVarianceMS   = 0;

   textureName          = "particleTest";

   colors[0]     = "0.46 0.36 0.26 1.0";
   colors[1]     = "0.46 0.36 0.26 0.0";
   sizes[0]      = 0.65;
   sizes[1]      = 0.30;
};

datablock ParticleEmitterData(refteleporterEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 1.1;
   velocityVariance = 1.0;
   ejectionOffset   = 2.0;
   
   thetaMin         = 0.0;
   thetaMax         = 10.0;
   
   phiReferenceVel  = 0.0;    // All phi angles
   phiVariance      = 360.0;

   overrideAdvances = false;
   particles = "refteleportparticle";
};


datablock ParticleData(refteleportparticle1)
{
   dragCoefficient      = 0.0;   // Not affected by drag
   gravityCoefficient   = -0.0;   // ...or gravity
   windCoefficient      = 0.0;

   inheritedVelFactor   = 0.2;   // Do not inherit emitters velocity
   constantAcceleration = 0.0;   // No constant accel along initial velocity

   lifetimeMS           = 1000;  // lasts 1 second
   lifetimeVarianceMS   = 0;     // ...exactly

   textureName          = "particleTest";

   colors[0]     = "1 1 1 1";    // All white, no blending
   colors[1]     = "0 0 0.75 0.8";
   colors[2]     = "0 0.75 0 0.6";
   colors[3]     = "0.75 0 0 0.4";

   sizes[0]      = 0.1;            // One meter across
   sizes[1]      = 0.15;
   sizes[2]      = 0.2;
   sizes[3]      = 0.25;

};

datablock ParticleEmitterData(refteleporterEmitter1)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 3.1;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   
   thetaMin         = 0.0;
   thetaMax         = 45.0;
   
   phiReferenceVel  = 0.0;    // All phi angles
   phiVariance      = 360.0;

   overrideAdvances = false;
   particles = "refteleportparticle1";
};

datablock ItemData(LightWhiteFast)
{
   catagory = "Misc";
//   shapeFile = "repair_kit.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 0;
   pickUpName = "a point light";
   alwaysAmbient = true;

   computeCRC = true;
   emap = true;

   lightOnlyStatic = true;
   lightType = "PulsingLight";
   lightColor = "1 1 1 0.8";
   lightTime = 300;
   lightRadius = 4;
};


datablock ItemData(LightWhiteSlow)
{
   catagory = "Misc";
//   shapeFile = "repair_kit.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 0;
   pickUpName = "a point light";
   alwaysAmbient = true;

   computeCRC = true;
   emap = true;

   lightOnlyStatic = true;
   lightType = "PulsingLight";
   lightColor = "1 1 1 0.8";
   lightTime = 1100;
   lightRadius = 4;
};

datablock ItemData(LightRedFast)
{
   catagory = "Misc";
//   shapeFile = "repair_kit.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 0;
   pickUpName = "a point light";
   alwaysAmbient = true;

   computeCRC = true;
   emap = true;

   lightOnlyStatic = true;
   lightType = "PulsingLight";
   lightColor = "1 0 0 0.8";
   lightTime = 350;
   lightRadius = 4;
};


datablock ItemData(LightRedSlow)
{
   catagory = "Misc";
//   shapeFile = "repair_kit.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 0;
   pickUpName = "a point light";
   alwaysAmbient = true;

   computeCRC = true;
   emap = true;

   lightOnlyStatic = true;
   lightType = "PulsingLight";
   lightColor = "1 0 0 0.8";
   lightTime = 900;
   lightRadius = 4;
};

datablock ItemData(LightGreenFast)
{
   catagory = "Misc";
//   shapeFile = "repair_kit.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 0;
   pickUpName = "a point light";
   alwaysAmbient = true;

   computeCRC = true;
   emap = true;

   lightOnlyStatic = true;
   lightType = "PulsingLight";
   lightColor = "0 1 0 0.8";
   lightTime = 500;
   lightRadius = 4;
};


datablock ItemData(LightGreenSlow)
{
   catagory = "Misc";
//   shapeFile = "repair_kit.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 0;
   pickUpName = "a point light";
   alwaysAmbient = true;

   computeCRC = true;
   emap = true;

   lightOnlyStatic = true;
   lightType = "PulsingLight";
   lightColor = "0 1 0 0.8";
   lightTime = 1050;
   lightRadius = 4;
};

datablock ItemData(LightBlueFast)
{
   catagory = "Misc";
//   shapeFile = "repair_kit.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 0;
   pickUpName = "a point light";
   alwaysAmbient = true;

   computeCRC = true;
   emap = true;

   lightOnlyStatic = true;
   lightType = "PulsingLight";
   lightColor = "0 0 1 0.8";
   lightTime = 450;
   lightRadius = 4;
};


datablock ItemData(LightBlueSlow)
{
   catagory = "Misc";
//   shapeFile = "repair_kit.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 0;
   pickUpName = "a point light";
   alwaysAmbient = true;

   computeCRC = true;
   emap = true;

   lightOnlyStatic = true;
   lightType = "PulsingLight";
   lightColor = "0 0 1 0.8";
   lightTime = 1000;
   lightRadius = 4;
};

