//Deployable Sensor Jammer


datablock SensorData(DeployJammerObj)
{
   detects = true;
   detectsUsingLOS = true;
   detectsActiveJammed = false;
   detectsPassiveJammed = true;
   detectsCloaked = false;
   detectionPings = true;
   detectMinVelocity = 2;
   detectRadius = 20;
};

datablock StaticShapeData(DeployedJammer) : StaticShapeDamageProfile
{
   className = Sensor;
   shapeFile = "pack_upgrade_sensorjammer.dts";
//   shapeFile = "ammo_disc.dts";
   maxDamage = 1.0;
   destroyedLevel = 1.0;
   disabledLevel = 1.0;
   dynamicType = $TypeMasks::StaticShapeObjectType;

   offset = "0 0 0";
   rotation = "1 0 0 90";

   deployedObject = true;

   isShielded = false;
   energyPerDamagePoint = 200;
   maxEnergy = 50;
   rechargeRate = 1.0;

   cmdCategory = "DSupport";
   cmdIcon = CMDSensorIcon;
   cmdMiniIconName = "commander/MiniIcons/com_deploymotionsensor";
   targetNameTag = 'Deployable';
   targetTypeTag = 'Jammer';
   sensorData = DeployJammerObj;
   sensorRadius = DeployJammerObj.detectRadius;
   sensorColor = "64 64 64";
   deployAmbientThread = true;

   debrisShapeName = "debris_generic_small.dts";
   debris = DeployableDebris;
   heatSignature = 0;

   explosion      = DeployablesExplosion;
      expDmgRadius = 6.0;
      expDamage = 0.20;
      expImpulse = 500.0;

   stateName[0] = "Idle";
   stateTransitionOnTriggerDown[0] = "Activate";

   stateName[1] = "Activate";
   stateSequence[1] = "fire";
   stateSound[1] = SensorJammerActivateSound;
   stateTransitionOnTriggerUp[1] = "Idle";

};

datablock ShapeBaseImageData(JammerDeployableImage)
{
   shapeFile = "pack_upgrade_sensorjammer.dts";
   item = JammerDeployable;
   mountPoint = 1;
   offset = "0 0 0";
   rotation = "0 1 0 180";
   deployed = DeployedJammer;

//   mass = 10.0;

   stateName[0] = "Idle";
   stateTransitionOnTriggerDown[0] = "Activate";

   stateName[1] = "Activate";
   stateScript[1] = "onActivate";
   stateTransitionOnTriggerUp[1] = "Idle";

   maxDepSlope = 360;
   deploySound = MotionSensorDeploySound;
   emap = true;
//   heatSignature = 1;

   minDeployDis                       =  0.5;
   maxDeployDis                       =  5.0;  //meters from body
};

datablock ItemData(JammerDeployable)
{
   className = Pack;
   catagory = "Deployables";
   shapeFile = "pack_upgrade_sensorjammer.dts";
   mass = 1.2;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 1;
   rotate = false;
   image = "JammerDeployableImage";
   pickUpName = "a deployable jammer pack";

   computeCRC = true;
   emap = true;
   heatSignature = 0;

//   maxSensors = 4;
};


datablock ShapeBaseImageData(DepJammerPackImage)
{
   shapeFile = "pack_upgrade_sensorjammer.dts";
   item = SensorJammerPack;
   mountPoint = 1;
   offset = "0 0 0.2";
   rotation = "1 0 0 90";

   usesEnergy = false;


   stateName[0] = "Idle";
   stateTransitionOnTriggerDown[0] = "Activate";
   stateTransitionOnTimeout[0] = "Activate";

   stateName[1] = "Activate";
   stateScript[1] = "onActivate";
   stateSequence[1] = "fire";
   stateSound[1] = SensorJammerActivateSound;
   stateTransitionOnTriggerUp[1] = "Deactivate";
   stateTransitionOnNoAmmo[1] = "Deactivate";
   stateTransitionOnTimeout[1] = "Activate";

   stateName[2] = "Deactivate";
   stateScript[2] = "onDeactivate";
   stateTransitionOnTimeout[2] = "Activate";
};

datablock ShapeBaseImageData(JammerDiscImage0)
{
   shapeFile = "ammo_disc.dts";
   mountPoint = 0;
   offset = "0 0 0.15";
   rotation = "1 0 0 90";
};


function DeployedJammer::onAdd(%this, %obj)
{
	StaticShapeData::onAdd(%this, %obj);

//	%obj.mountImage(DepJammerPackImage, 1);
//	%obj.jammerdevice = getMountNodeObject(1);
//	%obj.jammerdevice.schedule(10, "playThread", $ActivateThread, "activate");
//	%obj.setImageTrigger(1,true);
//	%obj.jammerdevice.client = %obj.owner;
//	%obj.playAudio(1, SensorJammerActivateSound);

	%obj.mountImage(JammerDiscImage0, 0);

	setTargetSensorData(%obj.target, JammerSensorObjectActive);
	%obj.schedule(10, "playThread", $ActivateThread, "activate");
	%obj.setJammerFX( true );
	%obj.playAudio(1, SensorJammerActivateSound);

}


function JammerDeployableImage::getInitialRotation(%item, %plyr)
{
   %rotAxis = vectorNormalize(vectorCross(%item.surfaceNrm, "0 0 1"));
   if (getWord(%item.surfaceNrm, 2) == 1 || getWord(%item.surfaceNrm, 2) == -1)
      %rotAxis = vectorNormalize(vectorCross(%item.surfaceNrm, "0 1 0"));     
   return %rotAxis SPC mACos(vectorDot(%item.surfaceNrm, "0 0 1"));
}


function DeployedJammer::damageObject(%data, %targetObject, %sourceObject, %position, %amount, %damageType)
{

   if (%targetObject.boom)
	return;

   StaticShapeData::damageObject(%data, %targetObject, %sourceObject, %position, %amount, %damageType);

   if (%targetObject.getDamageLevel() >= %data.maxDamage)
	%targetObject.setDamageState(Destroyed);

//   %targetObject.damagelevel += %amount;
//
//   if(%targetObject.damagelevel >= %data.maxDamage)
//   {   
//      %targetObject.setDamageState(Destroyed);
//   }
}

function DeployedJammer::onDestroyed(%data, %obj, %lastState)
{
   StaticShapeData::onDestroyed(%data, %obj, %lastState);
   %obj.boom = true;
   %mineTeam = %obj.team;
   $TeamDeployedCount[%mineTeam, JammerDeployable]--;
   %obj.schedule(300, "delete");
}


function JammerDeployableImage::onDeploy(%item, %plyr, %slot)
{
   %deplObj = Parent::onDeploy(%item, %plyr, %slot);

   %deplObj.damagelevel = 0;
   %deplObj.boom = false;

   return %deplObj;  
}
