//--------------------------------------------------------------------------
// Chaingun Turret
// 
// 
//--------------------------------------------------------------------------

//--------------------------------------------------------------------------
// Sounds
//--------------------------------------------------------------------------

datablock AudioProfile(ChainBarrelSwitchSound)
{
   filename    = "fx/powered/turret_heavy_activate.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(ChainBarrelFireSound)
{
   filename    = "fx/vehicles/tank_chaingun.wav";
   description = AudioDefault3d;
//   description = AudioDefaultLooping3d;
   preload = true;
};

datablock AudioProfile(ChainBarrelProjectile)
{
   filename    = "fx/weapons/chaingun_projectile.wav";
   description = ProjectileLooping3d;
   preload = true;
};


//--------------------------------------------------------------------------
// Explosion
//--------------------------------------------------------------------------


//--------------------------------------------------------------------------
// Projectile
//--------------------------------------
datablock DecalData(ChainBarrelDecal1)
{
   sizeX       = 0.05;
   sizeY       = 0.05;
   textureName = "special/bullethole1";
};
datablock DecalData(ChainBarrelDecal2) : ChainBarrelDecal1
{
   textureName = "special/bullethole2";
};

datablock DecalData(ChainBarrelDecal3) : ChainBarrelDecal1
{
   textureName = "special/bullethole3";
};
datablock DecalData(ChainBarrelDecal4) : ChainBarrelDecal1
{
   textureName = "special/bullethole4";
};
datablock DecalData(ChainBarrelDecal5) : ChainBarrelDecal1
{
   textureName = "special/bullethole5";
};
datablock DecalData(ChainBarrelDecal6) : ChainBarrelDecal1
{
   textureName = "special/bullethole6";
};

datablock TracerProjectileData(ChainBarrelBullet)
{
   doDynamicClientHits = true;

   directDamage        = 0.08;
   directDamageType    = $DamageType::ChainTurret;
   explosion           = "ChaingunExplosion";
   splash              = ChaingunSplash;

   kickBackStrength  = 10;
   sound 		= ChainBarrelProjectile;

   dryVelocity       = 425.0;
   wetVelocity       = 100.0;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 3000;
   lifetimeMS        = 3000;
   explodeOnDeath    = false;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 3000;

   tracerLength    = 20.0;
   tracerAlpha     = false;
   tracerMinPixels = 6;
   tracerColor     = 211.0/255.0 @ " " @ 215.0/255.0 @ " " @ 120.0/255.0 @ " 0.75";
	tracerTex[0]  	 = "special/tracer00";
	tracerTex[1]  	 = "special/tracercross";
	tracerWidth     = 0.10;
   crossSize       = 0.20;
   crossViewAng    = 0.990;
   renderCross     = true;

   decalData[0] = ChainBarrelDecal1;
   decalData[1] = ChainBarrelDecal2;
   decalData[2] = ChainBarrelDecal3;
   decalData[3] = ChainBarrelDecal4;
   decalData[4] = ChainBarrelDecal5;
   decalData[5] = ChainBarrelDecal6;
};

//--------------------------------------------------------------------------
// Plasma Turret Image
//--------------------------------------------------------------------------

datablock TurretImageData(ChainBarrelLarge)
{
//   shapeFile = "turret_missile_large.dts";
   shapeFile = "weapon_chaingun.dts";
   offset = "-0.04 -0.1 0.2";
   item      = ChainBarrelLargePack;

   projectile = ChainBarrelBullet;
   projectileType = TracerProjectile;
   usesEnergy = true;
   fireEnergy = 1;
   minEnergy = 3;
   emap = true;

   casing              = ShellDebris;
   shellExitDir        = "1.0 0.3 1.0";
   shellExitOffset     = "0.15 -0.56 -0.1";
   shellExitVariance   = 30.0;
   shellVelocity       = 6.0;

   projectileSpread = 16.0 / 1000.0;


   // Turret parameters
   activationMS      = 700;
   deactivateDelayMS = 1500;
   thinkTimeMS       = 200;
   degPerSecTheta    = 300;
   degPerSecPhi      = 500;
   attackRadius      = 95;



   //--------------------------------------
   stateName[0]                  = "Activate";
   stateSequence[0]              = "Activate";
   stateSound[0]                 = ChainBarrelSwitchSound;
   stateAllowImageChange[0]      = false;
   stateTimeoutValue[0]          = 0.6;
   stateTransitionOnTimeout[0]   = "Ready";
   stateTransitionOnNoAmmo[0]    = "NoAmmo";
   stateTransitionOnNotLoaded[0] = "Dead";

   //--------------------------------------
   stateName[1]                    = "Ready";
   stateSpinThread[1]              = Stop;
   stateTransitionOnTriggerDown[1] = "Spinup";
   stateTransitionOnNoAmmo[1]      = "NoAmmo";
   stateTransitionOnNotLoaded[0]   = "Deactivate";

   //--------------------------------------
   stateName[2]                    = "NoAmmo";
   stateTransitionOnAmmo[2]        = "Ready";
   stateSpinThread[2]              = Stop;
   stateTransitionOnTriggerDown[2] = "DryFire";
   stateTransitionOnNotLoaded[2]   = "Deactivate";

   //--------------------------------------
   stateName[3]                  = "Spinup";
   stateSpinThread[3]            = SpinUp;
//   stateSound[3]                 = ChaingunSpinupSound;
   stateTimeoutValue[3]          = 0.05;
   stateWaitForTimeout[3]        = false;
   stateTransitionOnTimeout[3]   = "Fire";
   stateTransitionOnTriggerUp[3] = "Spindown";

   //--------------------------------------
   stateName[4]                  = "Fire";
   stateSequence[4]              = "Fire";
   stateSequenceRandomFlash[4]   = true;
   stateSpinThread[4]            = FullSpeed;
   stateSound[4]                 = ChaingunFireSound;
   stateAllowImageChange[4]      = false;
   stateRecoil[4]                = LightRecoil;
   stateScript[4]                = "onFire";
   stateFire[4]                  = true;
   stateEjectShell[4]            = true;
   stateTimeoutValue[4]          = 0.15;
   stateTransitionOnTimeout[4]   = "Fire";
   stateTransitionOnTriggerUp[4] = "Spindown";
   stateTransitionOnNoAmmo[4]    = "EmptySpindown";

   //--------------------------------------
   stateName[5]                    = "Spindown";
//   stateSound[5]                   = ChaingunSpinDownSound;
   stateSpinThread[5]              = SpinDown;
   stateTimeoutValue[5]            = 0.05;
   stateWaitForTimeout[5]          = true;
   stateTransitionOnTimeout[5]     = "Ready";
   stateTransitionOnTriggerDown[5] = "Fire";

   //--------------------------------------
   stateName[6]                = "EmptySpindown";
   stateSound[6]               = ChaingunSpinDownSound;
   stateSpinThread[6]          = SpinDown;
   stateTimeoutValue[6]        = 1.0;
   stateTransitionOnTimeout[6] = "NoAmmo";
   
   //--------------------------------------
   stateName[7]                = "DryFire";
   stateSound[7]               = ChaingunDryFireSound;
   stateTimeoutValue[7]        = 0.2;
   stateTransitionOnTimeout[7] = "NoAmmo";

   stateName[8]                = "Deactivate";
   stateSequence[8]            = "Activate";
   stateDirection[8]           = false;
   stateTimeoutValue[8]        = 0.5;
   stateTransitionOnLoaded[8]  = "Ready";
   stateTransitionOnTimeout[8] = "Dead";

   stateName[9]               = "Dead";
   stateTransitionOnLoaded[9] = "Ready";


   // State transitions
//   stateName[0]                  = "Activate";
//   stateTransitionOnNotLoaded[0] = "Dead";
//   stateTransitionOnLoaded[0]    = "ActivateReady";
//
//   stateName[1]                  = "ActivateReady";
//   stateSequence[1]              = "Activate";
//   stateSound[1]                 = ChainBarrelSwitchSound;
//   stateTimeoutValue[1]          = 1;
//   stateTransitionOnTimeout[1]   = "Ready";
//   stateTransitionOnNotLoaded[1] = "Deactivate";
//   stateTransitionOnNoAmmo[1]    = "NoAmmo";
//
//   stateName[2]                    = "Ready";
//   stateTransitionOnNotLoaded[2]   = "Deactivate";
//   stateTransitionOnTriggerDown[2] = "Fire";
//   stateTransitionOnNoAmmo[2]      = "NoAmmo";
//
//   stateName[3]                = "Fire";
//   stateTransitionOnTimeout[3] = "Reload";
//   stateTimeoutValue[3]        = 0.07;
//   stateFire[3]                = true;
//   stateRecoil[3]              = LightRecoil;
//   stateAllowImageChange[3]    = false;
//   stateSequence[3]            = "Fire";
//   stateSound[3]               = ChainBarrelFireSound;
//   stateScript[3]              = "onFire";
//
//   stateName[4]                  = "Reload";
//   stateTimeoutValue[4]          = 0.03;
//   stateAllowImageChange[4]      = false;
//   stateSequence[4]              = "Reload";
//   stateTransitionOnTimeout[4]   = "Ready";
//   stateTransitionOnNotLoaded[4] = "Deactivate";
//   stateTransitionOnNoAmmo[4]    = "NoAmmo";
//
//   stateName[5]                = "Deactivate";
//   stateSequence[5]            = "Activate";
//   stateDirection[5]           = false;
//   stateTimeoutValue[5]        = 1;
//   stateTransitionOnLoaded[5]  = "ActivateReady";
//   stateTransitionOnTimeout[5] = "Dead";
//
//   stateName[6]               = "Dead";
//   stateTransitionOnLoaded[6] = "ActivateReady";
//
//   stateName[7]             = "NoAmmo";
//   stateTransitionOnAmmo[7] = "Reload";
//   stateSequence[7]         = "NoAmmo";
};

















