// Turret data


//--------------------------------------
// Projectile
//--------------------------------------
datablock TargetProjectileData(TurretTargeterBeam)
{
   directDamage        	= 0.0;
   hasDamageRadius     	= false;
   indirectDamage      	= 0.0;
   damageRadius        	= 0.0;
   velInheritFactor    	= 1.0;

   maxRifleRange       	= 400;
   beamColor           	= "0.1 1.0 0.4";
								
   startBeamWidth	= 0.20;
   pulseBeamWidth 	= 0.15;
   beamFlareAngle 	= 1.0;
   minFlareSize        	= 0.0;
   maxFlareSize        	= 200.0;
   pulseSpeed          	= 6.0;
   pulseLength         	= 0.150;

   textureName[0]      	= "special/nonlingradient";
   textureName[1]      	= "special/flare";
   textureName[2]      	= "special/pulse";
   textureName[3]      	= "special/expFlare";
   beacon               = true;
};


datablock SensorData(TargeterLaserSensor)
{
   detects = true;
   detectsUsingLOS = true;
   detectsActiveJammed = false;
   detectsPassiveJammed = false;
   detectsCloaked = true;
   detectionPings = true;
   detectRadius = 100;
//   detectMinVelocity = 2;
};

datablock TurretData(TargeterTurret) : TurretDamageProfile
{
   //className = Turret;
   catagory = "Turrets";
   shapeFile = "turret_sentry.dts";

   //Uses the same stats as an outdoor deployable turret (balancing info for Dave)
   mass = 5.0;

   barrel = TargeterTurretBarrel;

   maxDamage = 1.0;
   destroyedLevel = 1.0;
   disabledLevel = 4.5;
   explosion      = ShapeExplosion;
   expDmgRadius = 5.0;
   expDamage = 0.4;
   expImpulse = 1000.0;
   repairRate = 1;

   thetaMin = 89;
   thetaMax = 175;
   emap = true;
   

   isShielded           = true;
   energyPerDamagePoint = 50;
   maxEnergy = 200;
   rechargeRate = 1;

   canControl = true;
   cmdCategory = "Tactical";
   cmdIcon = CMDTurretIcon;
   cmdMiniIconName = "commander/MiniIcons/com_turret_grey";
   targetNameTag = 'Targeter';
   targetTypeTag = 'Turret';
   sensorData = TargeterLaserSensor;
   sensorRadius = TargeterLaserSensor.detectRadius;
   sensorColor = "9 180 200";
   firstPersonOnly = false;
};

datablock TurretImageData(TargeterTurretBarrel)
{
   shapeFile = "turret_muzzlepoint.dts";

   projectile = TurretTargeterBeam;
   projectileType = TargetProjectile;
   deleteLastProjectile = true;
   usesEnergy = true;
   fireEnergy = 0.1;
   minEnergy = 0.1;
   emap = true;

   // Turret parameters
   activationMS      = 300;
   deactivateDelayMS = 500;
   thinkTimeMS       = 200;
   degPerSecTheta    = 520;
   degPerSecPhi      = 960;
   attackRadius      = 100;


   stateName[0]                     = "Activate";
   stateSequence[0]                 = "Activate";
   stateSound[0]                    = SentryTurretSwitchSound;
   stateTimeoutValue[0]             = 0.5;
   stateTransitionOnTimeout[0]      = "ActivateReady";

   stateName[1]                     = "ActivateReady";
   stateTransitionOnAmmo[1]         = "Ready";
   stateTransitionOnNoAmmo[1]       = "NoAmmo";

   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateTransitionOnTriggerDown[2]  = "Fire";
   stateSquence[2]                  = "Ready";

   stateName[3]                     = "Fire";
   stateSquence[3]                  = "Fire";
//   stateEnergyDrain[3]              = 1;
   stateFire[3]                     = true;
   stateAllowImageChange[3]         = false;
   stateScript[3]                   = "onFire";
   stateTimeoutValue[3]             = 0.9;
   stateTransitionOnTimeout[3]      = "Deconstruction";
   stateTransitionOnTriggerUp[3]    = "Deconstruction";
   stateTransitionOnNoAmmo[3]       = "Deconstruction";
//   stateSound[3]                    = TargetingLaserPaintSound;

   stateName[4]                     = "NoAmmo";
   stateTransitionOnAmmo[4]         = "Ready";

   stateName[5]                     = "Deconstruction";
   stateScript[5]                   = "deconstruct";
   stateTimeoutValue[3]             = 0.1;
   stateTransitionOnTimeout[5]      = "Ready";
};

function TargeterTurretBarrel::onFire(%data,%obj,%slot)
{
   %p = Parent::onFire(%data, %obj, %slot);
   %p.setTarget(%obj.team);
}
