//------------------------------------------------------------------------------
datablock EffectProfile(VehicleAppearEffect)
{
   effectname = "vehicles/inventory_pad_appear";
   minDistance = 5;
   maxDistance = 10;
};

datablock EffectProfile(ActivateVehiclePadEffect)
{
   effectname = "powered/vehicle_pad_on";
   minDistance = 20;
   maxDistance = 30;
};

datablock AudioProfile(VehicleAppearSound)
{
   filename    = "fx/vehicles/inventory_pad_appear.wav";
   description = AudioClosest3d;
   preload = true;
   effect = VehicleAppearEffect;
};

datablock AudioProfile(ActivateVehiclePadSound)
{
   filename = 	"fx/powered/vehicle_pad_on.wav";
   description = AudioClose3d;
   preload = true;
   effect = ActivateVehiclePadEffect;
};

datablock StationFXVehicleData( VehicleInvFX )
{
   lifetime = 6.0;

   glowTopHeight = 1.5;
   glowBottomHeight = 0.1;
   glowTopRadius = 12.5;
   glowBottomRadius = 12.0;
   numGlowSegments = 26;
   glowFadeTime = 3.25;
   
   armLightDelay = 2.3;
   armLightLifetime = 3.0;
   armLightFadeTime = 1.5;
   numArcSegments = 10.0;

   sphereColor = "0.1 0.1 0.5";
   spherePhiSegments = 13;
   sphereThetaSegments = 8;
   sphereRadius = 12.0;
   sphereScale = "1.05 1.05 0.85";
   
   glowNodeName = "GLOWFX";

   leftNodeName[0]   = "LFX1";
   leftNodeName[1]   = "LFX2";
   leftNodeName[2]   = "LFX3";
   leftNodeName[3]   = "LFX4";

   rightNodeName[0]  = "RFX1";
   rightNodeName[1]  = "RFX2";
   rightNodeName[2]  = "RFX3";
   rightNodeName[3]  = "RFX4";


   texture[0] = "special/stationGlow";
   texture[1] = "special/stationLight2";
};

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
function serverCmdBuyVehicle(%client, %blockName)
{
   %team = %client.getSensorGroup();

//BONES MOD
//   if ((%blockname == ScoutVehicle) || (%blockname == AssaultVehicle) || (%blockname == MobileBaseVehicle) 
//   || (%blockname == ScoutFlyer) || (%blockname == BomberFlyer) || (%blockname == HAPCFlyer)) {
   if (%blockName.targetNameTag $= 'WildCat') {
	echo("Selected Bikes!");
	VehicleHud::updateHud( 0,%client,'vehicleHud', 1 );
   } else if (%blockName.targetNameTag $= 'Beowulf') {
	echo("Selected Tanks!");
	VehicleHud::updateHud( 0,%client,'vehicleHud', 2 );
   } else if (%blockName.targetNameTag $= 'Jericho') {
	echo("Selected Mobile Bases!");
	VehicleHud::updateHud( 0,%client,'vehicleHud', 3 );
   } else if (%blockName.targetNameTag $= 'Shrike') {
	echo("Selected Fighters!");
	VehicleHud::updateHud( 0,%client,'vehicleHud', 4 );
   } else if (%blockName.targetNameTag $= 'Thundersword') {
	echo("Selected Gunships!");
	VehicleHud::updateHud( 0,%client,'vehicleHud', 5 );
   } else if (%blockName.targetNameTag $= 'Havoc') {
	echo("Selected Transports!");
	VehicleHud::updateHud( 0,%client,'vehicleHud', 6 );
   } else {
     messageClient(%client, 'CloseHud', "", 'vehicleHud');
     if (%blockName.targetNameTag $= 'ScoutVehicle') {
	%blockName = ScoutVehicle;
     } else if (%blockName.targetNameTag $= 'AssaultVehicle') {
	%blockName = AssaultVehicle;
     } else if (%blockName.targetNameTag $= 'MobileBaseVehicle') {
	%blockName = MobileBaseVehicle;
     } else if (%blockName.targetNameTag $= 'ScoutFlyer') {
	%blockName = ScoutFlyer;
     } else if (%blockName.targetNameTag $= 'BomberFlyer') {
	%blockName = BomberFlyer;
     } else if (%blockName.targetNameTag $= 'HAPCFlyer') {
	%blockName = HAPCFlyer;
     }
//END MOD
   if(vehicleCheck(%blockName, %team))        
   {
      %station = %client.player.station.pad;
      if( (%station.ready) && (%station.station.vehicle[%blockName]) )
      {
         %trans = %station.getTransform();
         %pos = getWords(%trans, 0, 2);
         %matrix = VectorOrthoBasis(getWords(%trans, 3, 6));
         %yrot = getWords(%matrix, 3, 5);
         %p = vectorAdd(%pos,vectorScale(%yrot, -3));
         %p =  getWords(%p,0, 1) @ " " @ getWord(%p,2) + 4;

//         error(%blockName);
//         error(%blockName.spawnOffset);

         %p = vectorAdd(%p, %blockName.spawnOffset);
         %rot = getWords(%trans, 3, 5);
         %angle = getWord(%trans, 6) + 3.14;
         %mask = $TypeMasks::VehicleObjectType | $TypeMasks::PlayerObjectType | 
                 $TypeMasks::StationObjectType | $TypeMasks::TurretObjectType;
	      InitContainerRadiusSearch(%p, %blockName.checkRadius, %mask);
   
	      %clear = 1;
         for (%x = 0; (%obj = containerSearchNext()) != 0; %x++) 
         {
            if((%obj.getType() & $TypeMasks::VehicleObjectType) && (%obj.getDataBlock().checkIfPlayersMounted(%obj)))
            {
               %clear = 0;
               break;
            }
            else
               %removeObjects[%x] = %obj;
         }
//BONES MOD
	if (%station.isbusy == 1) {
		MessageClient(%client, "", 'Can\'t create vehicle. Vehicle Pad is busy.'); 		
	} else
//END MOD
         if(%clear)
         {
            %fadeTime = 0;
            for(%i = 0; %i < %x; %i++)
            {
               if(%removeObjects[%i].getType() & $TypeMasks::PlayerObjectType)
               {
                  %pData = %removeObjects[%i].getDataBlock();
                  %pData.damageObject(%removeObjects[%i], 0, "0 0 0", 1000, $DamageType::VehicleSpawn);
               }
               else
               {
                  %removeObjects[%i].mountable = 0;
                  %removeObjects[%i].startFade( 1000, 0, true );
                  %removeObjects[%i].schedule(1001, "delete");
//BONES MOD
                  %removeObjects[%i].getDataBlock().schedule(900, "onDelete",%removeObjects[%i]);
//END MOD
                  %fadeTime = 1500;
               }
            }
            schedule(%fadeTime, 0, "createVehicle", %client, %station, %blockName, %team , %p, %rot, %angle);
//BONES MOD
	    %station.isbusy = 1;
            schedule(%fadeTime+3000, 0, "stopbusy", %station);
//END MOD
         }
         else
            MessageClient(%client, "", 'Can\'t create vehicle. A player is on the creation pad.'); 
      }
   }
//BONES MOD
   }
//END MOD
}


//BONES MOD
function stopbusy(%station)
{
	%station.isbusy = 0;
}
//END MOD

function createVehicle(%client, %station, %blockName, %team , %pos, %rot, %angle)
{
   %obj = %blockName.create(%team);   
   if(%obj)
   {
      %station.ready = false;
      %obj.team = %team;
      %obj.useCreateHeight(true);
      %obj.schedule(5500, "useCreateHeight", false);
      %obj.getDataBlock().isMountable(%obj, false);
      %obj.getDataBlock().schedule(6500, "isMountable", %obj, true);
      
      %station.playThread($ActivateThread,"activate2");
      %station.playAudio($ActivateSound, ActivateVehiclePadSound);

      vehicleListAdd(%blockName, %obj);
      MissionCleanup.add(%obj);
                                  
      %turret = %obj.getMountNodeObject(10);
      if(%turret > 0)
      {
         %turret.setCloaked(true);
         %turret.schedule(4800, "setCloaked", false);
      }
      
      %obj.setCloaked(true);
      %obj.setTransform(%pos @ " " @ %rot @ " " @ %angle);
   
      %obj.schedule(3700, "playAudio", 0, VehicleAppearSound);
      %obj.schedule(4800, "setCloaked", false);
      
      if(%client.player.lastVehicle)
      {
         %client.player.lastVehicle.lastPilot = "";
         vehicleAbandonTimeOut(%client.player.lastVehicle);
         %client.player.lastVehicle = "";
      }   
      %client.player.lastVehicle = %obj;
      %obj.lastPilot = %client.player;

      // play the FX
      %fx = new StationFXVehicle()
      {
         dataBlock = VehicleInvFX;
         stationObject = %station;
      };

      if ( %client.isVehicleTeleportEnabled() )
         %obj.getDataBlock().schedule(5000, "mountDriver", %obj, %client.player);
   }
   if(%obj.getTarget() != -1)
      setTargetSensorGroup(%obj.getTarget(), %client.getSensorGroup());
   // We are now closing the vehicle hud when you buy a vehicle, making the following call
   // unnecessary (and it breaks stuff, too!)
   //VehicleHud.updateHud(%client, 'vehicleHud');
}

//------------------------------------------------------------------------------
function VehicleData::mountDriver(%data, %obj, %player)
{
   if(isObject(%obj) && %obj.getDamageState() !$= "Destroyed")
   {
      %player.startFade(1000, 0, true);
      schedule(1000, 0, "testVehicleForMount", %player, %obj);
      %player.schedule(1500,"startFade",1000, 0, false);
   }
}

function testVehicleForMount(%player, %obj)
{
   if(isObject(%obj) && %obj.getDamageState() !$= "Destroyed")
      %player.getDataBlock().onCollision(%player, %obj, 0);
}


//------------------------------------------------------------------------------
function VehicleData::checkIfPlayersMounted(%data, %obj)
{
   for(%i = 0; %i < %obj.getDatablock().numMountPoints; %i++)
      if (%obj.getMountNodeObject(%i))
         return true; 
   return false;
}

//------------------------------------------------------------------------------
function VehicleData::isMountable(%data, %obj, %val)
{
   %obj.mountable = %val;
}

//------------------------------------------------------------------------------
function vehicleCheck(%blockName, %team)
{
   if(($VehicleMax[%blockName] - $VehicleTotalCount[%team, %blockName]) > 0)
      return true;   
//   else
//   {
//      for(%i = 0; %i < $VehicleMax[%blockName]; %i++)
//      {
//         %obj = $VehicleInField[%blockName, %i];      
//         if(%obj.abandon)
//         {
//            vehicleListRemove(%blockName, %obj);
//            %obj.delete();
//            return true;
//         }
//      }
//   }
   return false;
}
	
//------------------------------------------------------------------------------
function VehicleHud::updateHud( %obj, %client, %tag, %menu )
{
   %station = %client.player.station;
// Not sure if we need to clear the huds... They'll always have the same num rows...
   //if ( %station.lastCount !$= "" )
   //   VehicleHud::clearHud( %client, %tag, %station.lastCount );

   %team = %client.getSensorGroup();
   %count = 0;
   %max = 0;

	echo("updatehud");

//BONES MOD
  if (%menu) {

	echo("MENU CALLED!");

	messageClient(%client, 'CloseHud', "", 'vehicleHud');
        VehicleHud::clearHud( 0,%client, %tag, 7 );
	messageClient(%client, 'OpenHud', "", 'vehicleHud');

   switch(%menu)
   {
	case 1:   // Bikes
	   if ( %station.vehicle[scoutVehicle] )
	   {
	      messageClient( %client, 'SetLineHud', "", %tag, %count, "WILDCAT GRAV CYCLE", "", WildCatGravbike, $VehicleMax[ScoutVehicle] - $VehicleTotalCount[%team, ScoutVehicle] );
	      %count++;
	   }
	   if ( %station.vehicle[BobcatVehicle] )
	   {
	      messageClient( %client, 'SetLineHud', "", %tag, %count, "BOBCAT GRAV CYCLE", "", BobcatVehicle, $VehicleMax[BobcatVehicle] - $VehicleTotalCount[%team, BobcatVehicle] );
	      %count++;
	   }
	   if ( %station.vehicle[HornetFlyer] )
	   {
	      messageClient( %client, 'SetLineHud', "", %tag, %count, "HORNET JETBIKE", "", HornetFlyer, $VehicleMax[HornetFlyer] - $VehicleTotalCount[%team, HornetFlyer] );
	      %count++;
	   }
	case 2:   // Tanks
	   if ( %station.vehicle[AssaultVehicle] )
	   {
	      messageClient( %client, 'SetLineHud', "", %tag, %count, "BEOWULF ASSAULT TANK", "", GravTank, $VehicleMax[AssaultVehicle] - $VehicleTotalCount[%team, AssaultVehicle] );
	      %count++;
	   }
	   if ( (%station.vehicle[LionVehicle]) && ($VehicleMax[LionVehicle] > 0))
	   {
	      messageClient( %client, 'SetLineHud', "", %tag, %count, "LION TORPEDO TANK", "", LionVehicle, $VehicleMax[LionVehicle] - $VehicleTotalCount[%team, LionVehicle] );
	      %count++;
	   }
	   if ( (%station.vehicle[PantherVehicle]) && ($VehicleMax[PantherVehicle] > 0))
	   {
	      messageClient( %client, 'SetLineHud', "", %tag, %count, "PANTHER PLASMA TANK", "", PantherVehicle, $VehicleMax[PantherVehicle] - $VehicleTotalCount[%team, PantherVehicle] );
	      %count++;
	   }
	   if ( (%station.vehicle[CheetahVehicle]) && ($VehicleMax[CheetahVehicle] > 0))
	   {
	      messageClient( %client, 'SetLineHud', "", %tag, %count, "CHEETAH CHAINGUN TANK", "", CheetahVehicle, $VehicleMax[CheetahVehicle] - $VehicleTotalCount[%team, CheetahVehicle] );
	      %count++;
	   }
	   if ( (%station.vehicle[PumaVehicle]) && ($VehicleMax[PumaVehicle] > 0))
	   {
	      messageClient( %client, 'SetLineHud', "", %tag, %count, "PUMA CLUSTER TANK", "", PumaVehicle, $VehicleMax[PumaVehicle] - $VehicleTotalCount[%team, PumaVehicle] );
	      %count++;
	   }
	   if ( (%station.vehicle[TigerVehicle]) && ($VehicleMax[TigerVehicle] > 0))
	   {
	      messageClient( %client, 'SetLineHud', "", %tag, %count, "TIGER MISSILE TANK", "", TigerVehicle, $VehicleMax[TigerVehicle] - $VehicleTotalCount[%team, TigerVehicle] );
	      %count++;
	   }
	case 3:   // Mobile Bases
	   if ( %station.vehicle[mobileBaseVehicle] )
	   {
	      messageClient( %client, 'SetLineHud', "", %tag, %count, "MOBILE POINT BASE", "", JerichoMPB, $VehicleMax[MobileBaseVehicle] - $VehicleTotalCount[%team, MobileBaseVehicle] );
	      %count++;
	   }
	   if ( %station.vehicle[CrusaderVehicle] )
	   {
	      messageClient( %client, 'SetLineHud', "", %tag, %count, "CRUSADER ARTILLERY BASE", "", CrusaderVehicle, $VehicleMax[CrusaderVehicle] - $VehicleTotalCount[%team, CrusaderVehicle] );
	      %count++;
	   }
	case 4:   // Fighters
	   if ( %station.vehicle[scoutFlyer] )
	   {
	      messageClient( %client, 'SetLineHud', "", %tag, %count, "SHRIKE SCOUT", "", ShrikeFlyer, $VehicleMax[ScoutFlyer] - $VehicleTotalCount[%team, ScoutFlyer] );
	      %count++;
	   }
	   if ( (%station.vehicle[HawkFlyer]) && ($VehicleMax[HawkFlyer] > 0))
	   {
	      messageClient( %client, 'SetLineHud', "", %tag, %count, "HAWK INTERCEPTOR", "", HawkFlyer, $VehicleMax[HawkFlyer] - $VehicleTotalCount[%team, HawkFlyer] );
	      %count++;
	   }
	   if ( (%station.vehicle[VultureFlyer]) && ($VehicleMax[VultureFlyer] > 0))
	   {
	      messageClient( %client, 'SetLineHud', "", %tag, %count, "VULTURE DEFENDER", "", VultureFlyer, $VehicleMax[VultureFlyer] - $VehicleTotalCount[%team, VultureFlyer] );
	      %count++;
	   }
	   if ( (%station.vehicle[OwlFlyer]) && ($VehicleMax[OwlFlyer] > 0))
	   {
	      messageClient( %client, 'SetLineHud', "", %tag, %count, "OWL TORPEDOER", "", OwlFlyer, $VehicleMax[OwlFlyer] - $VehicleTotalCount[%team, OwlFlyer] );
	      %count++;
	   }
	   if ( (%station.vehicle[SparrowFlyer]) && ($VehicleMax[SparrowFlyer] > 0))
	   {
	      messageClient( %client, 'SetLineHud', "", %tag, %count, "SPARROW SCOUT", "", SparrowFlyer, $VehicleMax[SparrowFlyer] - $VehicleTotalCount[%team, SparrowFlyer] );
	      %count++;
	   }
	   if ( %station.vehicle[SupportFlyer] )
	   {
	      messageClient( %client, 'SetLineHud', "", %tag, %count, "SUPPORT CRAFT", "", SupportFlyer, $VehicleMax[SupportFlyer] - $VehicleTotalCount[%team, SupportFlyer] );
	      %count++;
	   }
	   $VehicleMax[RavenFlyer] = $Host::BonesRavenMax;
	   if ( (%station.vehicle[RavenFlyer]) && ($VehicleMax[RavenFlyer] > 0))
	   {
	      messageClient( %client, 'SetLineHud', "", %tag, %count, "RAVEN MISSILER", "", RavenFlyer, $VehicleMax[RavenFlyer] - $VehicleTotalCount[%team, RavenFlyer] );
	      %count++;
	   }
	case 5:   // Gunships
	   if ( %station.vehicle[bomberFlyer] )
	   {
	      messageClient( %client, 'SetLineHud', "", %tag, %count, "THUNDERSWORD BOMBER", "", ThunderswordFlyer, $VehicleMax[BomberFlyer] - $VehicleTotalCount[%team, BomberFlyer] );
	      %count++;
	   }
	   if ( (%station.vehicle[EagleFlyer]) && ($VehicleMax[EagleFlyer] > 0))
	   {
	      messageClient( %client, 'SetLineHud', "", %tag, %count, "EAGLE GUNSHIP", "", EagleFlyer, $VehicleMax[EagleFlyer] - $VehicleTotalCount[%team, EagleFlyer] );
	      %count++;
	   }
	   if ( (%station.vehicle[CondorFlyer]) && ($VehicleMax[CondorFlyer] > 0))
	   {
	      messageClient( %client, 'SetLineHud', "", %tag, %count, "CONDOR GUNSHIP", "", CondorFlyer, $VehicleMax[CondorFlyer] - $VehicleTotalCount[%team, CondorFlyer] );
	      %count++;
	   }
	   if ( (%station.vehicle[TenderFlyer]) && ($VehicleMax[TenderFlyer] > 0))
	   {
	      messageClient( %client, 'SetLineHud', "", %tag, %count, "SUPPORT TENDER", "", TenderFlyer, $VehicleMax[TenderFlyer] - $VehicleTotalCount[%team, TenderFlyer] );
	      %count++;
	   }
	case 6:   // Transports
	   if ( %station.vehicle[hapcFlyer] )
	   {
	      messageClient( %client, 'SetLineHud', "", %tag, %count, "HAVOC TRANSPORT", "", HavocFlyer, $VehicleMax[HAPCFlyer] - $VehicleTotalCount[%team, HAPCFlyer] ); 
	      %count++;
	   }
	   if ( (%station.vehicle[AlbatrossFlyer]) && ($VehicleMax[AlbatrossFlyer] > 0))
	   {
	      messageClient( %client, 'SetLineHud', "", %tag, %count, "ALBATROSS GUNSHIP", "", AlbatrossFlyer, $VehicleMax[AlbatrossFlyer] - $VehicleTotalCount[%team, AlbatrossFlyer] );
	      %count++;
	   }

   }
   %station.lastCount = %count;
  } else  if (1) {

	echo("Top Menu!");

	%max = 0;
	if ( %station.vehicle[scoutVehicle] )
		%max += $VehicleMax[ScoutVehicle]  - $VehicleTotalCount[%team, ScoutVehicle];
	if ( %station.vehicle[BobcatVehicle] )
		%max += $VehicleMax[BobcatVehicle] - $VehicleTotalCount[%team, BobcatVehicle];
	if ( %station.vehicle[HornetFlyer] )
		%max += $VehicleMax[HornetFlyer]   - $VehicleTotalCount[%team, HornetFlyer];
	if (%max > 0)
           messageClient( %client, 'SetLineHud', "", %tag, %count, "BIKES", "", ScoutVehicle, %max );
	%count++;

	%max = 0;
	if ( %station.vehicle[AssaultVehicle] )
		%max += $VehicleMax[AssaultVehicle] - $VehicleTotalCount[%team, AssaultVehicle];
	if ( %station.vehicle[LionVehicle] )
		%max += $VehicleMax[LionVehicle]    - $VehicleTotalCount[%team, LionVehicle];
	if ( %station.vehicle[CheetahVehicle] )
		%max += $VehicleMax[CheetahVehicle] - $VehicleTotalCount[%team, CheetahVehicle];
	if ( %station.vehicle[PumaVehicle] )
		%max += $VehicleMax[PumaVehicle]    - $VehicleTotalCount[%team, PumaVehicle];
	if ( %station.vehicle[PantherVehicle] )
		%max += $VehicleMax[PantherVehicle] - $VehicleTotalCount[%team, PantherVehicle];
	if ( %station.vehicle[TigerVehicle] )
		%max += $VehicleMax[TigerVehicle]   - $VehicleTotalCount[%team, TigerVehicle];
	if (%max > 0)
           messageClient( %client, 'SetLineHud', "", %tag, %count, "TANKS", "", AssaultVehicle, %max );
	%count++;

	%max = 0;
	if ( %station.vehicle[MobileBaseVehicle] )
		%max += $VehicleMax[MobileBaseVehicle] - $VehicleTotalCount[%team, MobileBaseVehicle];
	if ( %station.vehicle[CrusaderVehicle] )
		%max += $VehicleMax[CrusaderVehicle]   - $VehicleTotalCount[%team, CrusaderVehicle];
	if (%max > 0)
           messageClient( %client, 'SetLineHud', "", %tag, %count, "MOBILE BASES", "", MobileBaseVehicle, %max );
	%count++;

	%max = 0;
	if ( %station.vehicle[ScoutFlyer] )
		%max += $VehicleMax[ScoutFlyer]   - $VehicleTotalCount[%team, ScoutFlyer];
	if ( %station.vehicle[HawkFlyer] )
		%max += $VehicleMax[HawkFlyer]    - $VehicleTotalCount[%team, HawkFlyer];
	if ( %station.vehicle[VultureFlyer] )
		%max += $VehicleMax[VultureFlyer] - $VehicleTotalCount[%team, VultureFlyer];
	if ( %station.vehicle[SparrowFlyer] )
		%max += $VehicleMax[SparrowFlyer] - $VehicleTotalCount[%team, SparrowFlyer];
	if ( %station.vehicle[OwlFlyer] )
		%max += $VehicleMax[OwlFlyer]     - $VehicleTotalCount[%team, OwlFlyer];
	if ( %station.vehicle[SupportFlyer] )  
		%max += $VehicleMax[SupportFlyer] - $VehicleTotalCount[%team, SupportFlyer];
	if (%max > 0)
           messageClient( %client, 'SetLineHud', "", %tag, %count, "FIGHTERS", "", ScoutFlyer, %max );
	%count++;

	%max = 0;
	if ( %station.vehicle[BomberFlyer] )
		%max += $VehicleMax[BomberFlyer] - $VehicleTotalCount[%team, BomberFlyer];
	if ( %station.vehicle[EagleFlyer] )
		%max += $VehicleMax[EagleFlyer]  - $VehicleTotalCount[%team, EagleFlyer];
	if ( %station.vehicle[CondorFlyer] )
		%max += $VehicleMax[CondorFlyer] - $VehicleTotalCount[%team, CondorFlyer];
	if ( %station.vehicle[TenderFlyer] )
		%max += $VehicleMax[TenderFlyer] - $VehicleTotalCount[%team, TenderFlyer];
	if (%max > 0)
           messageClient( %client, 'SetLineHud', "", %tag, %count, "GUNSHIPS", "", BomberFlyer, %max );
	%count++;

	%max = 0;
	if ( %station.vehicle[HAPCFlyer] )
		%max += $VehicleMax[HAPCFlyer]      - $VehicleTotalCount[%team, HAPCFlyer];
	if ( %station.vehicle[AlbatrossFlyer] )
		%max += $VehicleMax[AlbatrossFlyer] - $VehicleTotalCount[%team, AlbatrossFlyer];
	if (%max > 0)
           messageClient( %client, 'SetLineHud', "", %tag, %count, "TRANSPORTS", "", HAPCFlyer, %max );
	%count++;

  } else {
//END MOD

   if ( %station.vehicle[scoutVehicle] )
   {
      messageClient( %client, 'SetLineHud', "", %tag, %count, "GRAV CYCLE", "", ScoutVehicle, $VehicleMax[ScoutVehicle] - $VehicleTotalCount[%team, ScoutVehicle] );
//new      messageClient( %client, 'SetLineHud', "", %tag, %count, 'ScoutVehicle', $VehicleMax[ScoutVehicle] - $VehicleTotalCount[%team, ScoutVehicle], '', "GRAV CYCLE" );
      %count++;
   }
   if ( %station.vehicle[AssaultVehicle] )
   {
      messageClient( %client, 'SetLineHud', "", %tag, %count, "ASSAULT TANK", "", AssaultVehicle, $VehicleMax[AssaultVehicle] - $VehicleTotalCount[%team, AssaultVehicle] );
//new      messageClient( %client, 'SetLineHud', "", %tag, %count, 'AssaultVehicle', $VehicleMax[AssaultVehicle] - $VehicleTotalCount[%team, AssaultVehicle], '', "ASSAULT TANK");
      %count++;
   }
   if ( %station.vehicle[mobileBaseVehicle] )
   {
      messageClient( %client, 'SetLineHud', "", %tag, %count, "MOBILE POINT BASE", "", MobileBaseVehicle, $VehicleMax[MobileBaseVehicle] - $VehicleTotalCount[%team, MobileBaseVehicle] );
//new      messageClient( %client, 'SetLineHud', "", %tag, %count, 'MobileBaseVehicle', $VehicleMax[MobileBaseVehicle] - $VehicleTotalCount[%team, MobileBaseVehicle], '', "MOBILE POINT BASE" );
      %count++;
   }
   if ( %station.vehicle[scoutFlyer] )
   {
      messageClient( %client, 'SetLineHud', "", %tag, %count, "SCOUT FLIER", "", ScoutFlyer, $VehicleMax[ScoutFlyer] - $VehicleTotalCount[%team, ScoutFlyer] );
//new      messageClient( %client, 'SetLineHud', "", %tag, %count, 'ScoutFlyer', $VehicleMax[ScoutFlyer] - $VehicleTotalCount[%team, ScoutFlyer], '', "SCOUT FLIER");
      %count++;
   }
   if ( %station.vehicle[bomberFlyer] )
   {
      messageClient( %client, 'SetLineHud', "", %tag, %count, "THNUDERSWORD BOMBER", "", BomberFlyer, $VehicleMax[BomberFlyer] - $VehicleTotalCount[%team, BomberFlyer] );
//new      messageClient( %client, 'SetLineHud', "", %tag, %count, 'BomberFlyer', $VehicleMax[BomberFlyer] - $VehicleTotalCount[%team, BomberFlyer], '', "BOMBER");
      %count++;
   }
   if ( %station.vehicle[hapcFlyer] )
   {
      messageClient( %client, 'SetLineHud', "", %tag, %count, "HAVOC TRANSPORT", "", HAPCFlyer, $VehicleMax[HAPCFlyer] - $VehicleTotalCount[%team, HAPCFlyer] ); 
//new      messageClient( %client, 'SetLineHud', "", %tag, %count, 'HAPCFlyer', $VehicleMax[HAPCFlyer] - $VehicleTotalCount[%team, HAPCFlyer], '', "TRANSPORT"); 
      %count++;
   }
//BONES MOD
  }
//END MOD

   %station.lastCount = %count;
}

//------------------------------------------------------------------------------
function VehicleHud::clearHud( %obj, %client, %tag, %count )
{
   for ( %i = 0; %i < %count; %i++ )
      messageClient( %client, 'RemoveLineHud', "", %tag, %i );
}

//------------------------------------------------------------------------------
function serverCmdEnableVehicleTeleport( %client, %enabled )
{
   %client.setVehicleTeleportEnabled( %enabled );
}																							  
