//**************************************************************
// VULTURE HEAVY DEFENDER FLIER
//**************************************************************
//**************************************************************
// SOUNDS
//**************************************************************

//**************************************************************
// VEHICLE CHARACTERISTICS
//**************************************************************

datablock FlyingVehicleData(VultureFlyer) : ShrikeDamageProfile
{
   spawnOffset = "0 0 2";

   catagory = "Vehicles";
   shapeFile = "vehicle_air_scout.dts";
   multipassenger = false;
   computeCRC = true;

   debrisShapeName = "vehicle_air_scout_debris.dts";
   debris = ShapeDebris;
   renderWhenDestroyed = false;

   drag    = 0.15;
   density = 1.0;

//   lightOnly = 1;

   mountPose[0] = sitting;
   numMountPoints = 1;  
   isProtectedMountPoint[0] = true;
   cameraMaxDist = 15;
   cameraOffset = 2.5;
   cameraLag = 0.9;
   explosion = VehicleExplosion;
	explosionDamage = 0.5;
	explosionRadius = 5.0;

   maxDamage = 2.5;
   destroyedLevel = 2.5;

   isShielded = true;
   energyPerDamagePoint = 180;
   maxEnergy = 280;      // Afterburner and any energy weapon pool
   rechargeRate = 0.8;

   minDrag = 30;           // Linear Drag (eventually slows you down when not thrusting...constant drag)
   rotationalDrag = 900;        // Anguler Drag (dampens the drift after you stop moving the mouse...also tumble drag)

   maxAutoSpeed = 15;       // Autostabilizer kicks in when less than this speed. (meters/second)
   autoAngularForce = 400;       // Angular stabilizer force (this force levels you out when autostabilizer kicks in)
   autoLinearForce = 300;        // Linear stabilzer force (this slows you down when autostabilizer kicks in)
   autoInputDamping = 0.95;      // Dampen control input so you don't` whack out at very slow speeds
   
   // Maneuvering
   maxSteeringAngle = 5;    // Max radiens you can rotate the wheel. Smaller number is more maneuverable.
   horizontalSurfaceForce = 6;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
   verticalSurfaceForce = 4;     // Vertical center "wing" (controls side slip. lower numbers make MORE slide.)
   maneuveringForce = 1900;      // Horizontal jets (W,S,D,A key thrust)
   steeringForce = 1400;         // Steering jets (force applied when you move the mouse)
   steeringRollForce = 400;      // Steering jets (how much you heel over when you turn)
   rollForce = 4;                // Auto-roll (self-correction to right you after you roll/invert)
   hoverHeight = 5;        // Height off the ground at rest
   createHoverHeight = 3;  // Height off the ground when created
   maxForwardSpeed = 85;  // speed in which forward thrust force is no longer applied (meters/second)

   // Turbo Jet
   jetForce = 3300;      // Afterburner thrust (this is in addition to normal thrust)
   minJetEnergy = 28;     // Afterburner can't be used if below this threshhold.
   jetEnergyDrain = 2.8;       // Energy use of the afterburners (low number is less drain...can be fractional)                                                                                                                                                                                                                                                                                          // Auto stabilize speed
   vertThrustMultiple = 3.0;

   // Rigid body
   mass = 150;        // Mass of the vehicle
   bodyFriction = 0;     // Don't mess with this.
   bodyRestitution = 0.5;   // When you hit the ground, how much you rebound. (between 0 and 1)
   minRollSpeed = 0;     // Don't mess with this.
   softImpactSpeed = 14;       // Sound hooks. This is the soft hit.
   hardImpactSpeed = 25;    // Sound hooks. This is the hard hit.

   // Ground Impact Damage (uses DamageType::Ground)
   minImpactSpeed = 10;      // If hit ground at speed above this then it's an impact. Meters/second
   speedDamageScale = 0.06;

   // Object Impact Damage (uses DamageType::Impact)
   collDamageThresholdVel = 23.0;
   collDamageMultiplier   = 0.02;

   //
   minTrailSpeed = 15;      // The speed your contrail shows up at.
   trailEmitter = ContrailEmitter;
   forwardJetEmitter = FlyerJetEmitter;
   downJetEmitter = FlyerJetEmitter;

   //
   jetSound = BomberFlyerThrustSound;
   engineSound = ScoutFlyerEngineSound;
   softImpactSound = SoftImpactSound;
   hardImpactSound = HardImpactSound;
   //wheelImpactSound = WheelImpactSound;
   
   //
   softSplashSoundVelocity = 10.0; 
   mediumSplashSoundVelocity = 15.0;   
   hardSplashSoundVelocity = 20.0;   
   exitSplashSoundVelocity = 10.0;
   
   exitingWater      = VehicleExitWaterMediumSound;
   impactWaterEasy   = VehicleImpactWaterSoftSound;
   impactWaterMedium = VehicleImpactWaterMediumSound;
   impactWaterHard   = VehicleImpactWaterMediumSound;
   waterWakeSound    = VehicleWakeMediumSplashSound; 
    
   dustEmitter = VehicleLiftoffDustEmitter;
   triggerDustHeight = 4.0;
   dustHeight = 1.0;

   damageEmitter[0] = LightDamageSmoke;
   damageEmitter[1] = HeavyDamageSmoke;
   damageEmitter[2] = DamageBubbles;
   damageEmitterOffset[0] = "0.0 -3.0 0.0 ";
   damageLevelTolerance[0] = 0.3;
   damageLevelTolerance[1] = 0.7;
   numDmgEmitterAreas = 1;

   //
   max[chaingunAmmo] = 1000;

   minMountDist = 4;

   splashEmitter[0] = VehicleFoamDropletsEmitter;
   splashEmitter[1] = VehicleFoamEmitter;

   shieldImpact = VehicleShieldImpact;

   cmdCategory = "Tactical";
   cmdIcon = CMDFlyingScoutIcon;
   cmdMiniIconName = "commander/MiniIcons/com_scout_grey";
   targetNameTag = 'Vulture';
   targetTypeTag = 'Turbograv';
   sensorData = AWACPulseSensor;
   sensorRadius = AWACPulseSensor.detectRadius;
   sensorColor = "255 194 9";
   
   checkRadius = 5.5;
   observeParameters = "1 10 10";

   runningLight[0] = ShrikeLight1;
//   runningLight[1] = ShrikeLight2;

   shieldEffectScale = "0.937 1.125 0.60";

};



//**************************************************************
// WEAPONS
//**************************************************************

datablock ShapeBaseImageData(VultureBlasterPairImage)
{
   className = WeaponImage;
   shapeFile = "turret_aa_large.dts";
   projectile = ScoutChaingunBullet;
   projectileType = TracerProjectile;
   mountPoint = 10;
//**original**   offset = ".73 0 0";
   offset = "1.5 0.8 0.5";
   rotation = "0 1 0 -90";

   projectileSpread = 1.0 / 1000.0;

   usesEnergy = true;
   useMountEnergy = true;
   minEnergy = 5;
   fireEnergy = 5;
//   fireTimeout = 125;

   
   // State transitions
   stateName[0]                     = "Activate";
   stateSequence[0]                 = "Activate";
   stateSound[0]                    = AASwitchSound;
   stateTimeoutValue[0]             = 0.01;
   stateTransitionOnTimeout[0]      = "Ready";
   stateTransitionOnNotLoaded[0]    = "Deactivate";
   stateTransitionOnNoAmmo[0]       = "NoAmmo";
//   stateScript[0]                   = "AAActivateReady";

   stateName[1]                     = "Ready";
   stateTransitionOnNotLoaded[1]    = "Deactivate";
   stateTransitionOnTriggerDown[1]  = "Fire1";
   stateTransitionOnNoAmmo[1]       = "NoAmmo";
//   stateScript[1]                   = "AAReady";

   stateName[2]                     = "Fire1";
   stateTransitionOnTimeout[2]      = "Reload1";
   stateTimeoutValue[2]             = 0.09;
   stateFire[2]                     = true;
   stateRecoil[2]                   = LightRecoil;
   stateAllowImageChange[2]         = false;
   stateSequence[2]                 = "Fire1";
   stateSound[2]                    = ShrikeBlasterFire;
   stateScript[2]                   = "onFire";

   stateName[3]                     = "Reload1";
   stateTimeoutValue[3]             = 0.09;
   stateAllowImageChange[3]         = false;
   stateSequence[3]                 = "Reload";
   stateTransitionOnTimeout[3]      = "Fire2";
   stateTransitionOnNotLoaded[3]    = "Deactivate";
   stateTransitionOnNoAmmo[3]       = "NoAmmo";

   stateName[4]                     = "Fire2";
   stateTransitionOnTimeout[4]      = "Reload2";
   stateTimeoutValue[4]             = 0.09;
   stateFire[4]                     = true;
   stateRecoil[4]                   = LightRecoil;
   stateAllowImageChange[4]         = false;
   stateSequence[4]                 = "Fire2";
   stateSound[4]                    = ShrikeBlasterFire;
   stateScript[4]                   = "onFire";

   stateName[5]                     = "Reload2";
   stateTimeoutValue[5]             = 0.09;
   stateAllowImageChange[5]         = false;
   stateSequence[5]                 = "Reload";
   stateTransitionOnTimeout[5]      = "Ready";
   stateTransitionOnNotLoaded[5]    = "Deactivate";
   stateTransitionOnNoAmmo[5]       = "NoAmmo";

   stateName[6]                     = "Deactivate";
   stateSequence[6]                 = "Activate";
   stateDirection[6]                = false;
   stateTimeoutValue[6]             = 0.01;
   stateTransitionOnLoaded[6]       = "Ready";
   stateTransitionOnTimeout[6]      = "Deactivate";

   stateName[7]                    = "NoAmmo";
   stateTransitionOnAmmo[7]        = "Reload2";
   stateSequence[7]                = "NoAmmo";

//   stateName[10]                   = "Spinup";
//   stateSpinThread[10]             = SpinUp;
//   stateTimeoutValue[10]           = 0.01;
//   stateWaitForTimeout[10]         = false; 
//   stateTransitionOnTimeout[10]    = "Fire1";
//   stateTransitionOnTriggerUp[10]  = "Spindown";

//   stateName[11]                    = "Spindown";
//   stateSpinThread[11]              = SpinDown;
//   stateTimeoutValue[11]            = 0.01;
//   stateWaitForTimeout[11]          = false;
//   stateTransitionOnTimeout[11]     = "Ready";
//   stateTransitionOnTriggerDown[11] = "Spinup";
};

datablock ShapeBaseImageData(VultureBlasterImage) : VultureBlasterPairImage
{
//**original**   offset = "-.73 0 0";
   offset = "-1.5 0.8 0.5";
   rotation = "0 1 0 90";

   projectileSpread = 1.0 / 1000.0;

   stateScript[3]           = "onTriggerDown";
//   stateScript[4]           = "onTriggerUp";
//   stateScript[5]           = "onTriggerDown";
   stateScript[6]           = "onTriggerUp";
};

datablock ShapeBaseImageData(VultureBlasterParam)
{
   mountPoint = 2;
   shapeFile = "weapon_missile.dts";

   projectile = ScoutChaingunBullet;
   projectileType = TracerProjectile;
}; 

//********* FUNCTIONS ***********

function VultureFlyer::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);
   %obj.mountImage(VultureBlasterParam, 0);
   %obj.mountImage(VultureBlasterImage, 2);
   %obj.mountImage(VultureBlasterPairImage, 3);
   %obj.nextWeaponFire = 2;
   %obj.schedule(5500, "playThread", $ActivateThread, "activate");
//   %obj.getMountedImage(2).setThreadDir($DeployThread, true);
//   %obj.getMountedImage(2).playThread($DeployThread,"deploy");
//   %obj.getMountedImage(3).setThreadDir($DeployThread, true);
//   %obj.getMountedImage(3).playThread($DeployThread,"deploy");
}

function VultureFlyer::playerMounted(%data, %obj, %player, %node)
{
   // Vulture flyer == SUV (single-user vehicle)
   commandToClient(%player.client, 'setHudMode', 'Pilot', "Shrike", %node);
   $numVWeapons = 1;

   // update observers who are following this guy...
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );
}

function VultureFlyer::onTrigger(%data, %obj, %trigger, %state)
{
   // data = VultureFlyer datablock
   // obj = VultureFlyer object number
   // trigger = 0 for "fire", 1 for "jump", 3 for "thrust"
   // state = 1 for firing, 0 for not firing
   if(%trigger == 0)
   {
      switch (%state) {
         case 0:
            %obj.fireWeapon = false;
            %obj.setImageTrigger(2, false);
            %obj.setImageTrigger(3, false);
         case 1:
            %obj.setImageTrigger(2, true);
            %obj.setImageTrigger(3, true);
      }
   }
}

function VultureFlyer::playerDismounted(%data, %obj, %player)
{
   %obj.fireWeapon = false;
   %obj.setImageTrigger(2, false);
   %obj.setImageTrigger(3, false);
   setTargetSensorGroup(%obj.getTarget(), %obj.team);

   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, true );
}

function VultureBlasterImage::onFire(%data,%obj,%slot)
{
   // obj = RavenFlyer object number
   // slot = 2

   Parent::onFire(%data,%obj,%slot);
//   %obj.nextWeaponFire = 3;
//   schedule(%data.fireTimeout, 0, "fireNextGun", %obj);
}

function VultureBlasterPairImage::onFire(%data,%obj,%slot)
{
   // obj = ScoutFlyer object number
   // slot = 3

   Parent::onFire(%data,%obj,%slot);
//   %obj.nextWeaponFire = 2;
//   schedule(%data.fireTimeout, 0, "fireNextGun", %obj);
}
function VultureBlasterImage::onTriggerDown(%this, %obj, %slot)
{
}

function VultureBlasterImage::onTriggerUp(%this, %obj, %slot)
{
}

function VultureBlasterImage::onMount(%this, %obj, %slot)
{
//   %obj.setImageAmmo(%slot,true);
}

function VultureBlasterPairImage::onMount(%this, %obj, %slot)
{
//   %obj.setImageAmmo(%slot,true);
}

function VultureBlasterImage::onUnmount(%this,%obj,%slot)
{
}

function VultureBlasterPairImage::onUnmount(%this,%obj,%slot)
{
}
