//--------------------------------------
// Railgun
//--------------------------------------

//--------------------------------------------------------------------------
// Force-Feedback Effects
//--------------------------------------
datablock EffectProfile(RailgunFireEffect)
{
   effectname = "weapons/spinfusor_fire";
   MinDistance = 4.0;
};

datablock EffectProfile(RailgunSwitchEffect)
{
   effectname = "weapons/spinfusor_activate";
   MinDistance = 2.5;
};

datablock EffectProfile(RailgunDryFireEffect)
{
   effectname = "weapons/spinfusor_dryfire";
   MinDistance = 2.5;
};

datablock EffectProfile(RailgunReloadEffect)
{
   effectname = "weapons/spinfusor_reload";
   MinDistance = 2.5;
};

datablock EffectProfile(RailgunExpEffect)
{
   effectname = "explosions/grenade_explode";
   minDistance = 5;
   maxDistance = 20;
};

//--------------------------------------------------------------------------
// Sounds
//--------------------------------------
datablock AudioProfile(RailgunSwitchSound)
{
   filename    = "fx/weapons/generic_switch.wav";
   description = AudioClosest3d;
   preload = true;
   effect = RailgunSwitchEffect;
};

datablock AudioProfile(RailgunFireSound)
{
   filename    = "fx/weapons/plasma_dryfire.wav";
   description = AudioDefault3d;
   preload = true;
   effect = RailgunFireEffect;
};

datablock AudioProfile(RailgunReloadSound)
{
   filename    = "fx/weapons/mortar_reload.wav";
   description = AudioClosest3d;
   preload = true;
   effect = RailgunReloadEffect;
};

datablock AudioProfile(RailgunExpSound)
{
   filename    = "fx/weapons/grenade_explode.wav";
   description = AudioExplosion3d;
   preload = true;
   effect = GrenadeExplosionEffect;
};

datablock AudioProfile(UnderwaterRailgunExpSound)
{
   filename    = "fx/weapons/grenade_explode_UW.wav";
   description = AudioExplosion3d;
   preload = true;
   effect = GrenadeExplosionEffect;
};

datablock AudioProfile(RailgunProjectileSound)
{
   filename    = "fx/weapons/ELF_fire.wav";
   description = ProjectileLooping3d;
   preload = true;
};

datablock AudioProfile(RailgunDryFireSound)
{
   filename    = "fx/weapons/grenadelauncher_reload.wav";
   description = AudioClose3d;
   preload = true;
   effect = RailgunDryFireEffect;
};

datablock AudioProfile(RailgunWarmupSound)
{
//   filename    = "fx/vehicles/bomber_turret_activate.wav";
//   filename    = "fx/weapons/mine_switch.wav";
//   filename    = "fx/weapons/plasma_rifle_idle.wav";
   filename    = "fx/misc/mine.deploy.wav";
   description = AudioDefaultLooping3d;
   preload = true;
};

datablock AudioProfile(RailgunArmedSound)
{
   filename    = "gui/vote_nopass.wav";
   description = AudioClose3d;
   preload = true;
   effect = RailgunDryFireEffect;
};

//--------------------------------------------------------------------------
// Underwater Particle effects
//--------------------------------------------------------------------------
datablock ParticleData(RailgunExplosionBubbleParticle)
{
   dragCoefficient      = 0.0;
   gravityCoefficient   = -0.25;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 2000;
   lifetimeVarianceMS   = 750;
   useInvAlpha          = false;
   textureName          = "special/bubbles";

   spinRandomMin        = -100.0;
   spinRandomMax        =  100.0;

   colors[0]     = "0.7 0.8 1.0 0.0";
   colors[1]     = "0.7 0.8 1.0 0.4";
   colors[2]     = "0.7 0.8 1.0 0.0";
   sizes[0]      = 0.75;
   sizes[1]      = 0.75;
   sizes[2]      = 0.75;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};
datablock ParticleEmitterData(RailgunExplosionBubbleEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   ejectionOffset   = 2.0;
   velocityVariance = 0.5;
   thetaMin         = 0;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles = "RailgunExplosionBubbleParticle";
};

datablock ParticleData(UnderwaterRailgunExplosionSmoke)
{
   dragCoeffiecient     = 105.0;
   gravityCoefficient   = -0.0;   // rises slowly
   inheritedVelFactor   = 0.025;

   constantAcceleration = -1.0;
   
   lifetimeMS           = 1250;
   lifetimeVarianceMS   = 0;

   textureName          = "particleTest";

   useInvAlpha =  false;
   spinRandomMin = -200.0;
   spinRandomMax =  200.0;

   textureName = "special/Smoke/smoke_001";

   colors[0]     = "0.4 0.4 1.0 1.0";
   colors[1]     = "0.4 0.4 1.0 0.5";
   colors[2]     = "0.0 0.0 0.0 0.0";
   sizes[0]      = 1.0;
   sizes[1]      = 3.0;
   sizes[2]      = 5.0;
   times[0]      = 0.0;
   times[1]      = 0.2;
   times[2]      = 1.0;

};

datablock ParticleEmitterData(UnderwaterRailgunExplosionSmokeEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;

   ejectionVelocity = 5.25;
   velocityVariance = 0.25;

   thetaMin         = 0.0;
   thetaMax         = 180.0;

   lifetimeMS       = 250;

   particles = "UnderwaterRailgunExplosionSmoke";
};



datablock ParticleData(UnderwaterRailgunSparks)
{
   dragCoefficient      = 1;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 350;
   textureName          = "special/droplet";
   colors[0]     = "0.6 0.6 1.0 1.0";
   colors[1]     = "0.6 0.6 1.0 1.0";
   colors[2]     = "0.6 0.6 1.0 0.0";
   sizes[0]      = 0.5;
   sizes[1]      = 0.25;
   sizes[2]      = 0.25;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;

};

datablock ParticleEmitterData(UnderwaterRailgunSparkEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 6.75;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = true;
   lifetimeMS       = 100;
   particles = "UnderwaterRailgunSparks";
};



datablock ExplosionData(UnderwaterRailgunSubExplosion1)
{
   offset = 1.0;
   emitter[0] = UnderwaterRailgunExplosionSmokeEmitter;
   emitter[1] = UnderwaterRailgunSparkEmitter;
};

datablock ExplosionData(UnderwaterRailgunSubExplosion2)
{
   offset = 1.0;
   emitter[0] = UnderwaterRailgunExplosionSmokeEmitter;
   emitter[1] = UnderwaterRailgunSparkEmitter;
};

datablock ExplosionData(UnderwaterRailgunExplosion)
{
   soundProfile   = UnderwaterRailgunExpSound;

   emitter[0] = UnderwaterRailgunExplosionSmokeEmitter;
   emitter[1] = UnderwaterRailgunSparkEmitter;
   emitter[2] = RailgunExplosionBubbleEmitter;

//   subExplosion[0] = UnderwaterRailgunSubExplosion1;
//   subExplosion[1] = UnderwaterRailgunSubExplosion2;
   
   shakeCamera = true;
   camShakeFreq = "12.0 13.0 11.0";
   camShakeAmp = "35.0 35.0 35.0";
   camShakeDuration = 1.0;
   camShakeRadius = 15.0;
};

//--------------------------------------------------------------------------
// Particle effects
//--------------------------------------------------------------------------

datablock ParticleData(RailgunExplosionSmoke)
{
   dragCoeffiecient     = 105.0;
   gravityCoefficient   = -0.0;   // rises slowly
   inheritedVelFactor   = 0.025;

   constantAcceleration = -0.80;
   
   lifetimeMS           = 750;
   lifetimeVarianceMS   = 50;

   textureName          = "particleTest";

   useInvAlpha =  true;
   spinRandomMin = -200.0;
   spinRandomMax =  200.0;

   textureName = "special/Smoke/smoke_001";

   colors[0]     = "1.0 0.7 0.3 1.0";
   colors[1]     = "0.4 0.3 0.2 1.0";
   colors[2]     = "0.2 0.2 0.2 0.5";
   colors[3]     = "0.0 0.0 0.0 0.0";
   sizes[0]      = 1.0;
   sizes[1]      = 3.0;
   sizes[2]      = 4.0;
   sizes[3]      = 5.0;
   times[0]      = 0.0;
   times[1]      = 0.2;
   times[2]      = 0.5;
   times[3]      = 1.0;

};

datablock ParticleEmitterData(RailgunExplosionSmokeEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;

   ejectionVelocity = 9.0;
   velocityVariance = 0.5;

   thetaMin         = 0.0;
   thetaMax         = 180.0;

   lifetimeMS       = 250;

   particles = "RailgunExplosionSmoke";
};



datablock ParticleData(RailgunSparks)
{
   dragCoefficient      = 1;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 800;
   lifetimeVarianceMS   = 250;
   textureName          = "special/bigSpark";
   colors[0]     = "0.6 0.6 0.3 1.0";
   colors[1]     = "0.5 0.5 0.2 1.0";
   colors[2]     = "0.2 0.2 0.2 0.0";
   sizes[0]      = 0.5;
   sizes[1]      = 0.25;
   sizes[2]      = 0.25;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;

};

datablock ParticleEmitterData(RailgunSparkEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 20;
   velocityVariance = 8;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = true;
   lifetimeMS       = 100;
   particles = "RailgunSparks";
};




//----------------------------------------------------
//  Explosion
//----------------------------------------------------

datablock ExplosionData(RailgunSubExplosion1)
{
   offset = 0.1;
   emitter[0] = RailgunSparkEmitter;
   emitter[1] = RailgunExplosionSmokeEmitter;
};

datablock ExplosionData(RailgunSubExplosion2)
{
   offset = 0.2;
   emitter[0] = RailgunSparkEmitter;
//   emitter[1] = RailgunExplosionSmokeEmitter;
};

datablock ExplosionData(RailgunExplosion)
{
   soundProfile   = RailgunExpSound;

   emitter[0] = RailgunExplosionSmokeEmitter;
   emitter[1] = RailgunSparkEmitter;

   subExplosion[0] = RailgunSubExplosion1;
   subExplosion[1] = RailgunSubExplosion2;
   
   shakeCamera = true;
   camShakeFreq = "12.0 13.0 11.0";
   camShakeAmp = "10.0 10.0 10.0";
   camShakeDuration = 0.7;
   camShakeRadius = 7.0;
};


//--------------------------------------------------------------------------
// Projectile
//--------------------------------------
datablock TracerProjectileData(RailgunProjectile)
{
   doDynamicClientHits = true;

   directDamage        = 0.20;
   directDamageType    = $DamageType::Railgun;
   explosion           = "RailgunExplosion";
   underwaterExplosion = "UnderwaterRailgunExplosion";
   splash              = ChaingunSplash;

   hasDamageRadius     = true;
   indirectDamage      = 0.15;
   damageRadius        = 3.25;
   kickBackStrength    = 850;

   sound 		= RailgunProjectile;

   dryVelocity       = 350.0;
   wetVelocity       = 200.0;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 3000;
   lifetimeMS        = 3000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 3000;

   tracerLength    = 20.0;
   tracerAlpha     = false;
   tracerMinPixels = 6;
   tracerColor     = "1.0 0.8 0.2 0.75";
	tracerTex[0]  	 = "special/tracer00";
	tracerTex[1]  	 = "special/tracercross";
	tracerWidth     = 0.15;
   crossSize       = 0.20;
   crossViewAng    = 0.990;
   renderCross     = true;

   decalData[0] = ChaingunDecal1;
   decalData[1] = ChaingunDecal2;
   decalData[2] = ChaingunDecal3;
   decalData[3] = ChaingunDecal4;
   decalData[4] = ChaingunDecal5;
   decalData[5] = ChaingunDecal6;
};

datablock TracerProjectileData(AdminRailgunProjectile)
{
   doDynamicClientHits = true;

   directDamage        = 0.2;
   directDamageType    = $DamageType::Railgun;
   explosion           = "DiscExplosion";
   underwaterExplosion = "UnderwaterDiscExplosion";
   splash              = ChaingunSplash;

   hasDamageRadius     = true;
   indirectDamage      = 0.7;
   damageRadius        = 7.0;
   kickBackStrength    = 2000;

   sound 		= RailgunProjectile;

   dryVelocity       = 400.0;
   wetVelocity       = 250.0;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 3000;
   lifetimeMS        = 3000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 3000;

   tracerLength    = 20.0;
   tracerAlpha     = false;
   tracerMinPixels = 6;
   tracerColor     = "0.8 0.8 1.0 0.75";
	tracerTex[0]  	 = "special/tracer00";
	tracerTex[1]  	 = "special/tracercross";
	tracerWidth     = 0.15;
   crossSize       = 0.20;
   crossViewAng    = 0.990;
   renderCross     = true;

   decalData[0] = ChaingunDecal1;
   decalData[1] = ChaingunDecal2;
   decalData[2] = ChaingunDecal3;
   decalData[3] = ChaingunDecal4;
   decalData[4] = ChaingunDecal5;
   decalData[5] = ChaingunDecal6;
};


//--------------------------------------------------------------------------
// Ammo
//--------------------------------------

datablock ItemData(RailgunAmmo)
{
   className = Ammo;
   catagory = "Ammo";
   shapeFile = "ammo_chaingun.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "some railgun ammo";

   computeCRC = true;

};


//--------------------------------------------------------------------------
// Weapon
//--------------------------------------
datablock ItemData(Railgun)
{
   className = Weapon;
   catagory = "Spawn Items";
   shapeFile = "weapon_missile.dts";
   image = RailgunImage;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "a railgun";
   emap = true;
};
datablock ItemData(AdminRailgun)
{
   className = Weapon;
   catagory = "Spawn Items";
   shapeFile = "weapon_missile.dts";
   image = AdminRailgunImage;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "an admin railgun";
   emap = true;
};

datablock ShapeBaseImageData(RailgunImage)
{
   className = WeaponImage;
   shapeFile = "weapon_missile.dts";
   item = Railgun;
   offset = "0 0 0";
   emap = true;
   armThread = lookms;

   projectileSpread = 2.0 / 1000.0;

//   usesEnergy = true;
   fireEnergy = 6;
   minEnergy = 15;
   ammo 	 = RailgunAmmo;

   casing              = ShellDebris;
   shellExitDir        = "1.0 0.3 1.0";
   shellExitOffset     = "0.15 -0.56 -0.1";
   shellExitVariance   = 20.0;
   shellVelocity       = 6.0;

   projectile = RailgunProjectile;
   projectileType = TracerProjectile;

   // State Data
   stateName[0] = "Activate";
   stateTransitionOnTimeout[0] = "Warmup";
   stateTimeoutValue[0] = 0.5;
   stateSequence[0] = "Activate";
   stateSound[0] = RailgunSwitchSound;

   stateName[1] = "ActivateReady";
   stateTransitionOnNoAmmo[1] = "NoAmmo";
   stateTransitionOnLoaded[1] = "Ready";

   stateName[2] = "Ready";
   stateTransitionOnNoAmmo[2] = "NoAmmo";
   stateTransitionOnTriggerDown[2] = "Fire";

   stateName[3] = "Fire";
   stateTransitionOnTimeout[3] = "Reload";
   stateTimeoutValue[3] = 0.2;
   stateFire[3] = true;
   stateEjectShell[3]       = true;
   stateRecoil[3] = NoRecoil;
   stateAllowImageChange[3] = false;
   stateSequence[3] = "Fire";
//   stateSound[3] = RailgunFireSound;
   stateScript[3] = "onFire";

   stateName[4] = "Reload";
   stateTransitionOnNoAmmo[4] = "NoAmmo";
   stateTimeoutValue[4] = 0.3;
   stateTransitionOnTimeout[4] = "Ready";
   stateAllowImageChange[4] = false;
   stateSequence[4] = "Reload";
   stateSound[4] = RailgunReloadSound;

   stateName[5] = "NoAmmo";
   stateTransitionOnAmmo[5] = "Reload";
   stateSequence[5] = "NoAmmo";
   stateTransitionOnTriggerDown[5] = "DryFire";
   
   stateName[6] = "DryFire";
   stateTimeoutValue[6] = 0.8;
   stateSound[6] = RailgunDryFireSound;
   stateTransitionOnTimeout[6] = "Ready";

   stateName[7] = "WarmUp";
   stateTimeoutValue[7] = 6.0;
   stateSequence[7] = "WarmUp";
   stateSound[7] = RailgunWarmupSound;
   stateTransitionOnTimeout[7] = "Armed";

   stateName[8] = "Armed";
   stateTimeoutValue[8] = 0.2;
   stateSound[8] = RailgunArmedSound;
   stateTransitionOnTimeout[8] = "ActivateReady";
};

datablock ShapeBaseImageData(AdminRailgunImage)
{
   className = WeaponImage;
   shapeFile = "weapon_missile.dts";
   item = AdminRailgun;
   offset = "0 0 0";
   emap = true;
   armThread = lookms;

   usesEnergy = true;
   fireEnergy = 4;
   minEnergy = 4;
//   ammo 	 = RailgunAmmo;

   casing              = ShellDebris;
   shellExitDir        = "1.0 0.3 1.0";
   shellExitOffset     = "0.15 -0.56 -0.1";
   shellExitVariance   = 20.0;
   shellVelocity       = 6.0;

   projectile = AdminRailgunProjectile;
   projectileType = TracerProjectile;

   // State Data
   stateName[0] = "Activate";
   stateTransitionOnTimeout[0] = "Warmup";
   stateTimeoutValue[0] = 0.5;
   stateSequence[0] = "Activate";
   stateSound[0] = RailgunSwitchSound;

   stateName[1] = "ActivateReady";
   stateTransitionOnNoAmmo[1] = "NoAmmo";
   stateTransitionOnLoaded[1] = "Ready";

   stateName[2] = "Ready";
   stateTransitionOnNoAmmo[2] = "NoAmmo";
   stateTransitionOnTriggerDown[2] = "Fire";

   stateName[3] = "Fire";
   stateTransitionOnTimeout[3] = "Reload";
   stateTimeoutValue[3] = 0.3;
   stateFire[3] = true;
   stateEjectShell[3]       = true;
   stateRecoil[3] = NoRecoil;
   stateAllowImageChange[3] = false;
   stateSequence[3] = "Fire";
   stateSound[3] = RailgunFireSound;
   stateScript[3] = "onFire";

   stateName[4] = "Reload";
   stateTransitionOnNoAmmo[4] = "NoAmmo";
   stateTimeoutValue[4] = 0.2;
   stateTransitionOnTimeout[4] = "Ready";
   stateAllowImageChange[4] = false;
   stateSequence[4] = "Reload";
   stateSound[4] = RailgunReloadSound;

   stateName[5] = "NoAmmo";
   stateTransitionOnAmmo[5] = "Reload";
   stateSequence[5] = "NoAmmo";
   stateTransitionOnTriggerDown[5] = "DryFire";
   
   stateName[6] = "DryFire";
   stateTimeoutValue[6] = 0.8;
   stateSound[6] = RailgunDryFireSound;
   stateTransitionOnTimeout[6] = "Ready";

   stateName[7] = "WarmUp";
   stateTimeoutValue[7] = 2.0;
   stateSequence[7] = "WarmUp";
   stateSound[7] = RailgunWarmupSound;
   stateTransitionOnTimeout[7] = "Armed";

   stateName[8] = "Armed";
   stateTimeoutValue[8] = 0.2;
   stateSound[8] = RailgunArmedSound;
   stateTransitionOnTimeout[8] = "ActivateReady";
};

function RailgunImage::onFire(%data,%obj,%slot)
{
   %energy = %obj.getEnergyLevel();
   if(%energy < %data.minEnergy)
	{
	  serverPlay3D(RailgunDryFireSound, %obj.getTransform());
          return;
	} else
	  serverPlay3D(RailgunFireSound, %obj.getTransform());
   %obj.setEnergyLevel(%energy - %data.fireEnergy);
   Parent::onFire(%data,%obj,%slot);
}
